<?php

namespace App\Http\Controllers\Admin\AppSetting;

use Response;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage;
use App\Http\Controllers\Controller;
use App\Models\AnnouncementBar;
use DataTables;

class AnnouncementBarController extends Controller
{

    public function __construct()
    {
    }

    public function index()
    {
        return view('admin.app-setting.announce-bar.announcement-bar');
    }

    public function getAnnouncementBar(Request $request)
    {
        if ($request->ajax()) {
            $data = AnnouncementBar::get();
            return DataTables::of($data)
                ->addIndexColumn()
                ->addColumn('action', function ($row) {
                    $btn = '<a href="'.url('/').'/admin/app-setting/announcement-bar/edit/'.$row->id.'" class="edit btn btn-primary btn-sm">Edit</a><a href="javascript:void(0)" class="delete btn btn-danger btn-sm ml-2" data-id="'.$row->id.'">Delete</a>';
                    return $btn;
                })

                ->rawColumns(['action'])

                ->make(true);
        }
    }

    public function add()
    {
        return view('admin.app-setting.announce-bar.add');
    }

    public function store(Request $request)
    {
        $announcement =  AnnouncementBar::create([
                'text_english' => $request->text_english,
                'text_arabic' => $request->text_arabic,
                'start_date' => $request->start_date,
                'end_date' => $request->end_date,
            ]);
        if ($announcement) {
            return response()->json([
                'success' => true,
                'msg' => 'Record saved successfully.'
            ]);
        } else {
            return response()->json([
                'success' => false,
                'msg' => 'Something went wrong.'
            ]);
        }
    }

    public function edit($id)
    {
        $announcement = AnnouncementBar::where('id', $id)->first();
        return view('admin.app-setting.announce-bar.edit', compact('announcement'));
    }

    public function update(Request $request)
    {
        $announcement = AnnouncementBar::where('id', $request->id)->update([
            'text_english' => $request->text_english,
            'text_arabic' => $request->text_arabic,
            'start_date' => $request->start_date,
            'end_date' => $request->end_date,
        ]);
        return response()->json([
            'success' => true,
            'msg' => 'Record updated successfully.'
        ]);
    }

    public function delete(Request $request)
    {
        $announcement = AnnouncementBar::where('id', $request->id)->delete();
        return response()->json([
            'success' => true,
            'msg' => 'Record deleted successfully.'
        ]);
    }
}
