<?php

namespace App\Http\Controllers\Admin\AppSetting;

use App\Http\Controllers\Controller;
use App\Models\AppVersion;
use Illuminate\Http\Request;

class AppVersionController extends Controller
{
    public function index(){
        return view('admin.app-setting.app-version');
    }
    

    public function list()
    {
        $app_version = AppVersion::first();
        return response()->json([
            'success' => true,
            'app_version' => $app_version,
        ]);
    }

    public function store(Request $request){
        if (isset($request->id)) {
            AppVersion::where('id', $request->id)->update([
                'android_version' => $request->android_version,
                'ios_version' => $request->ios_version,
            ]);
        } else {
            AppVersion::create([
                'android_version' => $request->android_version,
                'ios_version' => $request->ios_version,
            ]);
        }
        $app_version = AppVersion::first();
        return response()->json([
            'success' => true,
            'app_version' => $app_version,
            'msg' => 'Record saved successfully.',
        ]);
    }
}
