<?php

namespace App\Http\Controllers\Admin\AppSetting\Dashboard;

use App\Exports\AddToCartExport;
use App\Exports\AlertNotificationExport;
use App\Exports\AnalyticExport;
use App\Exports\CheckoutStepExport;
use App\Exports\CurrencyExport;
use App\Exports\FaqExport;
use App\Exports\IntroExport;
use App\Exports\ManualNotificationExport;
use App\Exports\MenuListExport;
use App\Exports\MilestoneCountExport;
use App\Exports\OrderFromExport;
use App\Exports\ProductDetailCount;
use App\Exports\ProductScanCountExport;
use App\Exports\RemindSentExport;
use App\Exports\SearchTermExport;
use App\Exports\ViewCollectionExport;
use App\Exports\ViewProductExport;
use App\Exports\RemoveCartExport;
use App\Http\Controllers\Controller;
use App\Models\AddCartProductFrom;
use App\Models\AlertNotification;
use App\Models\Cart;
use App\Models\CategoryFAQ;
use App\Models\ChallengeSection;
use App\Models\CheckoutStepCount;
use App\Models\Collection;
use App\Models\ContactUs;
use App\Models\CountryCurrency;
use App\Models\Currency;
use App\Models\Customer;
use App\Models\DeviceOrderFrom;
use App\Models\ExclusiveViewAll;
use App\Models\FaqClickCount;
use App\Models\IntroSkip;
use App\Models\ManualNotification;
use App\Models\ManualNotificationCount;
use App\Models\MenuClickCount;
use App\Models\Milestone;
use App\Models\MilestoneViewCount;
use App\Models\NotifyMe;
use App\Models\Product;
use App\Models\ProductDetailsCount;
use App\Models\RemindNotification;
use App\Models\ScanProductCount;
use App\Models\SearchTerm;
use App\Models\UserToken;
use App\Models\Variant;
use App\Models\ViewCollectionCount;
use App\Models\ViewProductCount;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use Mockery\Matcher\Not;
use Yajra\DataTables\Facades\DataTables;

class DashboardController extends Controller
{
    public function index()
    {
        $permission = (array)DB::table('permission_user')->where('user_id', Auth::id())->first();
        $role = (array)DB::table('role_user')->where('user_id', Auth::id())->first();
        if (count($role) > 0) {
            return view('admin.dashboard');
        } else {
            if (count($permission) > 0) {
                if (Auth::user()->hasPermission('dashboard-read')) {
                    return view('admin.dashboard');
                }
                if (Auth::user()->hasPermission('announcement_bar-read')) {
                    return view('admin.app-setting.announce-bar.announcement-bar');
                }
                if (Auth::user()->hasPermission('menu-read')) {
                    return view('admin.app-setting.menu.index');
                }

                if (Auth::user()->hasPermission('app_version-read')) {
                    return view('admin.app-setting.app-version');
                }
                if (Auth::user()->hasPermission('flash_sale-read')) {
                    return view('admin.app-setting.flash-sale.add');
                }
                if (Auth::user()->hasPermission('products-read')) {
                    return view('admin.product.product-list');
                }
                if (Auth::user()->hasPermission('collections-read')) {
                    return view('admin.collection.list');
                }
                if (Auth::user()->hasPermission('categories-read')) {
                    return view('admin.app-setting.category.index');
                }
                if (Auth::user()->hasPermission('faq-read')) {
                    return view('admin.app-setting.categoryFAQ.index');
                }
                if (Auth::user()->hasPermission('email-setting-read')) {
                    return view('admin.app-setting.email-setting.index');
                }
                if (Auth::user()->hasPermission('science_page-read')) {
                    return view('admin.app-setting.science-page.index');
                }
                if (Auth::user()->hasPermission('recommend_product-read')) {
                    return view('admin.app-setting.recommend-product.index');
                }
                if (Auth::user()->hasPermission('review_product-read')) {
                    return view('admin.app-setting.review.index');
                }
                if (Auth::user()->hasPermission('product_categories-read')) {
                    return view('admin.app-setting.product-category.list');
                }
                if (Auth::user()->hasPermission('notifyme-read')) {
                    return view('admin.app-setting.notification.notification');
                }
                if (Auth::user()->hasPermission('manual_notifications-read')) {
                    return view('admin.app-setting.manual-notification.list');
                }
                if (Auth::user()->hasPermission('customers-read')) {
                    return view('admin.app-setting.customer.list');
                }
                if (Auth::user()->hasPermission('challenges-read')) {
                    return view('admin.app-setting.challenge.index');
                }
                if (Auth::user()->hasPermission('challenge_contents-read')) {
                    $challengeSection = ChallengeSection::get();
                    return view('admin.app-setting.challenge.add', compact('challengeSection'));
                }
                if (Auth::user()->hasPermission('milestones-read')) {
                    return view('admin.app-setting.milestone.add');
                }
            } else {
                return view('admin.dashboardpermission');
            }
        }
    }

    public function productDetail(Request $request)
    {
        $exclusiveAll       = 0;
        // if($request->start_date != NULL && $request->end_date != NULL){
        //     $english = UserToken::where('language_id', 'en')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //     $arabic  = UserToken::where('language_id', 'ar')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();

        //     $remove_cart_count  = Cart::where('is_delete', 1)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
            
        //     $introDetail        = IntroSkip::whereBetween('step', [1, 3])->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('step');
        //     $checkoutDetail     = CheckoutStepCount::whereBetween('step', [1, 3])->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('step');
        //     $orderFromDetail    = DeviceOrderFrom::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('from');

        //     $menuDetail         = MenuClickCount::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('menu');
        //     $scanWrongCount     = ScanProductCount::where('product_id', '=', NULL)->where('name', 'scan_wrong')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //     $contact_us         = ContactUs::whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //     $addCartDetail      = AddCartProductFrom::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('from');
        //     $exclusiveAll       = ExclusiveViewAll::whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        // }else{
        //     if($request->start_date != NULL && $request->end_date == NULL){
        //         $english = UserToken::where('language_id', 'en')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
        //         $arabic  = UserToken::where('language_id', 'ar')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
    
        //         $remove_cart_count  = Cart::where('is_delete', 1)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
                
        //         $introDetail        = IntroSkip::whereBetween('step', [1, 3])->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('step');
        //         $checkoutDetail     = CheckoutStepCount::whereBetween('step', [1, 3])->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('step');
        //         $orderFromDetail    = DeviceOrderFrom::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('from');
    
        //         $menuDetail         = MenuClickCount::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('menu');
        //         $scanWrongCount     = ScanProductCount::where('product_id', '=', NULL)->where('name', 'scan_wrong')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
        //         $contact_us         = ContactUs::whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
        //         $addCartDetail      = AddCartProductFrom::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('from');
        //         $exclusiveAll       = ExclusiveViewAll::whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();

        //     }elseif($request->end_date != NULL && $request->start_date == NULL){
        //         $userTokenDate  = UserToken::min('created_at');
        //         $removeCartDate = Cart::where('is_delete', 1)->min('created_at');
        //         $introDate      = IntroSkip::min('created_at');
        //         $checkDate      = CheckoutStepCount::min('created_at');
        //         $orderFromDate  = DeviceOrderFrom::min('created_at');
        //         $menuDate       = MenuClickCount::min('created_at');
        //         $scanDate       = ScanProductCount::min('created_at');
        //         $contactDate    = ContactUs::min('created_at');
        //         $addCartDate    = AddCartProductFrom::min('created_at');
        //         $exclusiveDate    = ExclusiveViewAll::min('created_at');
        //         if($userTokenDate){
        //             $english = UserToken::where('language_id', 'en')->whereBetween('created_at', [date('Y-m-d', strtotime($userTokenDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //             $arabic  = UserToken::where('language_id', 'ar')->whereBetween('created_at', [date('Y-m-d', strtotime($userTokenDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //         }else{
        //             $english = UserToken::where('language_id', 'en')->count();
        //             $arabic  = UserToken::where('language_id', 'ar')->count();
        //         }

        //         if($removeCartDate){
        //             $remove_cart_count  = Cart::where('is_delete', 1)->whereBetween('created_at', [date('Y-m-d', strtotime($removeCartDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //         }else{
        //             $remove_cart_count  = Cart::where('is_delete', 1)->count();
        //         }

        //         if($introDate){
        //             $introDetail        = IntroSkip::whereBetween('step', [1, 3])->get()->whereBetween('created_at', [date('Y-m-d', strtotime($introDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('step');
        //         }else{
        //             $introDetail        = IntroSkip::whereBetween('step', [1, 3])->get()->groupBy('step');
        //         }

        //         if($checkDate){
        //             $checkoutDetail     = CheckoutStepCount::whereBetween('step', [1, 3])->get()->whereBetween('created_at', [date('Y-m-d', strtotime($checkDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('step');
        //         }else{
        //             $checkoutDetail     = CheckoutStepCount::whereBetween('step', [1, 3])->get()->groupBy('step');
        //         }

        //         if($orderFromDate){
        //             $orderFromDetail    = DeviceOrderFrom::get()->whereBetween('created_at', [date('Y-m-d', strtotime($orderFromDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('from');
        //         }else{
        //             $orderFromDetail    = DeviceOrderFrom::get()->groupBy('from');
        //         }

        //         if($menuDate){
        //             $menuDetail         = MenuClickCount::get()->whereBetween('created_at', [date('Y-m-d', strtotime($menuDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('menu');
        //         }else{
        //             $menuDetail         = MenuClickCount::get()->groupBy('menu');
        //         }

        //         if($scanDate){
        //             $scanWrongCount     = ScanProductCount::where('product_id', '=', NULL)->where('name', 'scan_wrong')->whereBetween('created_at', [date('Y-m-d', strtotime($scanDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //         }else{
        //             $scanWrongCount     = ScanProductCount::where('product_id', '=', NULL)->where('name', 'scan_wrong')->count();
        //         }

        //         if($contactDate){
        //             $contact_us         = ContactUs::whereBetween('created_at', [date('Y-m-d', strtotime($contactDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //         }else{
        //             $contact_us         = ContactUs::count();
        //         }

        //         if($addCartDate){
        //             $addCartDetail      = AddCartProductFrom::get()->whereBetween('created_at', [date('Y-m-d', strtotime($addCartDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('from');
        //         }else{
        //             $addCartDetail      = AddCartProductFrom::get()->groupBy('from');
        //         }

        //         if($exclusiveDate){
        //             $exclusiveAll      = ExclusiveViewAll::whereBetween('created_at', [date('Y-m-d', strtotime($exclusiveDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
        //         }else{
        //             $exclusiveAll       = ExclusiveViewAll::count();
        //         }
                
        //     }else{
        //         $english = UserToken::where('language_id', 'en')->count();
        //         $arabic  = UserToken::where('language_id', 'ar')->count();
                
        //         $remove_cart_count  = Cart::where('is_delete', 1)->count();
                
        //         $introDetail        = IntroSkip::whereBetween('step', [1, 3])->get()->groupBy('step');
        //         $checkoutDetail     = CheckoutStepCount::whereBetween('step', [1, 3])->get()->groupBy('step');
        //         $orderFromDetail    = DeviceOrderFrom::get()->groupBy('from');
                
        //         $menuDetail         = MenuClickCount::get()->groupBy('menu');
        //         $scanWrongCount     = ScanProductCount::where('product_id', '=', NULL)->where('name', 'scan_wrong')->count();
        //         $contact_us         = ContactUs::count();
        //         $addCartDetail      = AddCartProductFrom::get()->groupBy('from');
        //         $exclusiveAll       = ExclusiveViewAll::count();
        //     }
        // }

                $englishObj = new UserToken();
                $arabicObj  = new UserToken();
                
                $removeObj  = new Cart();
                
                $introObj        = new IntroSkip();
                $checkoutObj     = new CheckoutStepCount();
                $orderFromObj    = new DeviceOrderFrom();
                
                $menuObj         = new MenuClickCount();
                $scanWrongObj     = new ScanProductCount();
                $contactObj         = new ContactUs();
                $addCartObj      = new AddCartProductFrom();
                $exclusiveObj       = new ExclusiveViewAll();

                $englishObj = $englishObj->where('language_id', 'en');
                $arabicObj = $arabicObj->where('language_id', 'ar');
                $removeObj = $removeObj->where('is_delete', 1);
                $scanWrongObj = $scanWrongObj->where('product_id', '=', NULL);

                if ($request->start_date) {
                    $startDate      = date('Y-m-d', strtotime($request->start_date));

                    $englishObj     = $englishObj->whereDate('created_at', '>=',$startDate);
                    $arabicObj      = $arabicObj->whereDate('created_at', '>=',$startDate);
                    $removeObj      = $removeObj->whereDate('created_at', '>=',$startDate);
                    $introObj       = $introObj->whereDate('created_at', '>=',$startDate);
                    $checkoutObj    = $checkoutObj->whereDate('created_at', '>=',$startDate);
                    $orderFromObj   = $orderFromObj->whereDate('created_at', '>=',$startDate);
                    $menuObj        = $menuObj->whereDate('created_at', '>=',$startDate);
                    $scanWrongObj   = $scanWrongObj->whereDate('created_at', '>=',$startDate);
                    $contactObj     = $contactObj->whereDate('created_at', '>=',$startDate);
                    $addCartObj     = $addCartObj->whereDate('created_at', '>=',$startDate);
                    $exclusiveObj   = $exclusiveObj->whereDate('created_at', '>=',$startDate);
                }
                if ($request->end_date) {
                    $endDate = date('Y-m-d', strtotime($request->end_date));

                    $englishObj     = $englishObj->whereDate('created_at', '<=',$endDate);
                    $arabicObj      = $arabicObj->whereDate('created_at', '<=',$endDate);
                    $removeObj      = $removeObj->whereDate('created_at', '<=',$endDate);
                    $introObj       = $introObj->whereDate('created_at', '<=',$endDate);
                    $checkoutObj    = $checkoutObj->whereDate('created_at', '<=',$endDate);
                    $orderFromObj   = $orderFromObj->whereDate('created_at', '<=',$endDate);
                    $menuObj        = $menuObj->whereDate('created_at', '<=',$endDate);
                    $scanWrongObj   = $scanWrongObj->whereDate('created_at', '<=',$endDate);
                    $contactObj     = $contactObj->whereDate('created_at', '<=',$endDate);
                    $addCartObj     = $addCartObj->whereDate('created_at', '<=',$endDate);
                    $exclusiveObj   = $exclusiveObj->whereDate('created_at', '<=',$endDate);

                }

                $english =  $englishObj->count();
                $arabic  =  $arabicObj->count();
                
                $remove_cart_count  = $removeObj->count();
                
                $introDetail        = $introObj->whereBetween('step', [1, 3])->get()->groupBy('step');
                $checkoutDetail     = $checkoutObj->whereBetween('step', [1, 3])->get()->groupBy('step');
                $orderFromDetail    = $orderFromObj->get()->groupBy('from');
                
                $menuDetail         = $menuObj->get()->groupBy('menu');
                $scanWrongCount     = $scanWrongObj->where('name', 'scan_wrong')->count();
                $contact_us         = $contactObj->count();
                $addCartDetail      = $addCartObj->get()->groupBy('from');
                $exclusiveAll       = $exclusiveObj->count();

        $active     = Product::where('active', '=', 1)->count();
        $inactive   = Product::where('active', '=', 0)->count();


        $intro = [];
        $introData = [];
        foreach($introDetail as $key => $value){
            $intro['step'] = $key;
            $intro['count'] = count($value);
            $introData[] = $intro;

        }

        $check = [];
        $checkoutData = [];
        foreach($checkoutDetail as $key => $value){
            $check['step'] = $key;
            $check['count'] = count($value);
            $checkoutData[] = $check;

        }

        $orderFrom = [];
        $orderFromData = [];
        foreach($orderFromDetail as $key => $value){
            $orderFrom['from'] = ucwords($key);
            $orderFrom['count'] = count($value);
            $orderFromData[] = $orderFrom;

        }

        $menu = [];
        $menuData = [];
        foreach($menuDetail as $key => $value){
            $menu['menu'] = ucwords(str_replace('_', ' ', $key));
            $menu['count'] = count($value);
            $menuData[] = $menu;

        }

        // $addCartDetail    = AddCartProductFrom::get()->map(function ($data) {
        //     $data->from = ucwords($data->from);
        //     return $data;
        // });

        $addCartData    = [];
        $addCartFrom    = [];
        foreach($addCartDetail as $key => $value){
            $addCartData['from'] = ucwords(str_replace('_', ' ', $key));
            $addCartData['count'] = count($addCartDetail[$key]);
            $addCartFrom[] = $addCartData;

        }
        // $exclusive      = ExclusiveViewAll::get();
        // if (count($exclusive) > 0) {
        //     $exclusiveAll = $exclusive[0]->count;
        // }

        $product = [
            'active'    => $active != NULL ? $active : 0,
            'inactive'  => $inactive != NULL ? $inactive : 0,
        ];

        $customer = [
            'english' => $english != NULL ? $english : 0,
            'arabic'  => $arabic != NULL ? $arabic : 0,
        ];

        $remove_cart = [
            'data' => $remove_cart_count != NULL ? $remove_cart_count : 0,
        ];
        if ($product) {
            return response()->json([
                'success'               => true,
                'product'               => $product,
                'customer'              => $customer,
                'orders'                => $orderFromData,
                'remove_cart'           => $remove_cart,
                'contact_us'            => $contact_us != NULL ? $contact_us : 0,
                'exclusive'             => $exclusiveAll,
                'scanWrongCount'        => $scanWrongCount,
                'intro'                 => $introData,
                'checkout_step'         => $checkoutData,
                'menu'                  => $menuData,
                'addCartFrom'           => $addCartFrom,
            ]);
        } else {
            return response()->json([
                'success' => false,
                'msg' => 'Something went wrong!'
            ]);
        }
    }

    public function getCurrencyCount(Request $request)
    {
        $currencyDetail     = [];
        $currencyCountData  = [];

        if ($request->ajax()) {

            $clickObj = new UserToken();
    
            if($request->start_date){
                $start_date =  date('Y-m-d', strtotime($request->start_date));
                $clickObj = $clickObj->whereDate('created_at', '>=', $start_date);
            }
            if($request->end_date){
                $end_date =  date('Y-m-d', strtotime($request->end_date));
                $clickObj = $clickObj->whereDate('created_at', '<=', $end_date);
            }
            $currencies = $clickObj->get()->groupBy('currency');

            // $currencies = UserToken::get()->groupBy('currency');

            foreach ($currencies as $key => $value) {
                if ($key != NULL) {
                    $country = CountryCurrency::where('code', $key)->where('flag', '!=', NULL)->first();
                    $currencyDetail['currency'] =  $country != NULL ? $country->country . " (" . $key . ") " : $key;
                    $currencyDetail['count'] = count($currencies[$key]) != NULL ? count($currencies[$key]) : 0;
                    $currencyCountData[] = $currencyDetail;
                }
            }
            return DataTables::of($currencyCountData)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getMilestoneCount(Request $request)
    {
        $milestoneData = [];
        $milestoneDetail = [];

        if ($request->ajax()) {
            $milestones = Milestone::get();
            foreach ($milestones as $key => $value) {
                $customerObj = new Customer();
                $milestoneViewObj = new MilestoneViewCount();

                if($request->start_date){
                    $customerObj = $customerObj->where('milestone_id', $value->id)->whereDate('created_at', '>=', date('Y-m-d', strtotime($request->start_date)));
                    $milestoneViewObj = $milestoneViewObj->where('milestone_id', $value->id)->whereDate('created_at', '>=', date('Y-m-d', strtotime($request->start_date)));
                }
                if($request->end_date){
                    $customerObj = $customerObj->where('milestone_id', $value->id)->whereDate('created_at', '<=', date('Y-m-d', strtotime($request->end_date)));
                    $milestoneViewObj = $milestoneViewObj->where('milestone_id', $value->id)->whereDate('created_at', '<=', date('Y-m-d', strtotime($request->end_date)));
                }
                $milestoneCount =  $customerObj->where('milestone_id', $value->id)->count();
                $viewCount = $milestoneViewObj->where('milestone_id', $value->id)->count();
                // if($request->start_date != NULL && $request->end_date != NULL){
                //     $milestoneCount = Customer::where('milestone_id', $value->id)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                //     $viewCount = MilestoneViewCount::where('milestone_id', $value->id)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                // }else{
                //     if($request->start_date != NULL && $request->end_date == NULL){
                //         $milestoneCount = Customer::where('milestone_id', $value->id)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
                //         $viewCount = MilestoneViewCount::where('milestone_id', $value->id)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
                //     }elseif($request->end_date != NULL && $request->start_date == NULL){
                //         $date = Customer::min('created_at');
                //         $viewDate = MilestoneViewCount::min('created_at');
                //         if($date){
                //             $milestoneCount = Customer::where('milestone_id', $value->id)->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                //             $viewCount = MilestoneViewCount::where('milestone_id', $value->id)->whereBetween('created_at', [date('Y-m-d', strtotime($viewDate. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                //         }else{
                //             $milestoneCount = Customer::where('milestone_id', $value->id)->count();
                //             $viewCount = MilestoneViewCount::where('milestone_id', $value->id)->count();
                //         }
                //     }else{
                //         $milestoneCount = Customer::where('milestone_id', $value->id)->count();
                //         $viewCount = MilestoneViewCount::where('milestone_id', $value->id)->count();
                //     }
                // }
                $milestoneData['level'] = $value->level_english;
                $milestoneData['count'] = $milestoneCount;
                $milestoneData['view_count'] = $viewCount;
                $milestoneDetail[] = $milestoneData;
            }
            return DataTables::of($milestoneDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getManualNotification()
    {
        $notificationData = [];
        $notificationDetail = [];
        $sent       = ManualNotification::where('status', '=', 1)->count();
        $open       = ManualNotification::where('status', '=', 0)->count();
        $immidiate  = ManualNotification::where('date', '=', NULL)->count();
        $automated  = ManualNotification::where('date', '!=', NULL)->count();
        array_push($notificationDetail, array('name' => 'Sent', 'count' => $sent), array('name' => 'Open', 'count' => $open), array('name' => 'Immidiate', 'count' => $immidiate), array('name' => 'Automated', 'count' => $automated));
        $data = ManualNotification::get()->groupBy('destination_type');
        // echo "<pre>";
        // print_r($data->toArray());die;
        foreach ($data as $key => $d) {
            if ($key != NULL) {
                $notificationData['name'] = ucwords(str_replace('_', ' ', $key));
                $notificationData['count'] = count($data[$key]);
                $notificationDetail[] = $notificationData;
            }
        }
        return $notificationDetail;
    }

    public function getManualNotificationCount(Request $request)
    {
        $notificationData = [];
        $notificationDetail = [];
        // $startDate = $request->start_date;
        // $endDate = $request->end_date;

        // $data = new ManualNotification();
        // if($request->start_date){
        //     $start_date =  date('Y-m-d', strtotime($request->start_date));
        //     $data = $data->whereDate('created_at', '>=', $start_date);
        // }
        // if($request->end_date){
        //     $end_date =  date('Y-m-d', strtotime($request->end_date));
        //     $data = $data->whereDate('created_at', '<=', $end_date);
        // }
        // $data = $data->get();

        $clickObj = new ManualNotificationCount();
        // $clickObj = $clickObj->where('manual_id', $value->id);

        if($request->start_date){
            $start_date =  date('Y-m-d', strtotime($request->start_date));
            $clickObj = $clickObj->whereDate('created_at', '>=', $start_date);
        }
        if($request->end_date){
            $end_date =  date('Y-m-d', strtotime($request->end_date));
            $clickObj = $clickObj->whereDate('created_at', '<=', $end_date);
        }
        $data = $clickObj->get()->groupBy('manual_id');
        foreach ($data as $key => $value) {
            if($key != NULL){
                $manual = ManualNotification::where('id', $key)->first();
                if($manual){
                    // $countTotal = $clickObj->count();
                    $notificationData['title_english'] =  $manual->title_english;
                    $notificationData['notification_type'] =  $manual->date == NULL ? 'Immidiate' : 'Scheduled';
                    $notificationData['destination_type'] =  $manual->destination_type == NULL ?  'Not Available' : ucwords(str_replace('_', ' ', $manual->destination_type));
                    $notificationData['click_count'] =  count($value);
                    $notificationDetail[] = $notificationData;
                }
            }
        }

        // if($request->start_date != NULL && $request->end_date != NULL){
        //     $manuals = ManualNotification::get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->map(function($data) use ( $startDate, $endDate){
        //         if($data->date == NULL){
        //             $data->notification_type = 'Immidiate';
        //         }elseif($data->date != NULL){
        //             $data->notification_type = 'Scheduled';
        //         }
        //         if($data->destination_type == NULL){
        //             $data->destination_type = 'Not Available';
        //         }else{
        //             $data->destination_type = ucwords(str_replace('_', ' ', $data->destination_type));
        //         }
        //         $data->click_count = ManualNotificationCount::where('manual_id', $data->id)->whereBetween('created_at', [date('Y-m-d', strtotime($startDate. ' - 1 days')),date('Y-m-d', strtotime($endDate. ' + 1 days'))])->count();
        //         return $data;
        //     });
        // }else{
        //     if($request->start_date != NULL && $request->end_date == NULL){
        //         $manuals = ManualNotification::get()->whereBetween('created_at', [$request->start_date, now()->format('Y-m-d')])->map(function($data) use ( $startDate){
        //             if($data->date == NULL){
        //                 $data->notification_type = 'Immidiate';
        //             }elseif($data->date != NULL){
        //                 $data->notification_type = 'Scheduled';
        //             }
        //             if($data->destination_type == NULL){
        //                 $data->destination_type = 'Not Available';
        //             }else{
        //                 $data->destination_type = ucwords(str_replace('_', ' ', $data->destination_type));
        //             }
        //             $data->click_count = ManualNotificationCount::where('manual_id', $data->id)->whereBetween('created_at', [date('Y-m-d', strtotime($startDate. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
        //             return $data;
        //         });
        //     }elseif($request->end_date != NULL && $request->start_date == NULL){
        //         $date = ManualNotification::min('created_at');
        //         if($date){
        //             $input = strtotime($date); 
        //             $only_start =  date('Y-m-d ', $input);
        //             $manuals = ManualNotification::get()->whereBetween('created_at', [$only_start, $request->end_date])->map(function($data) use ( $date, $endDate){
        //                 if($data->date == NULL){
        //                     $data->notification_type = 'Immidiate';
        //                 }elseif($data->date != NULL){
        //                     $data->notification_type = 'Scheduled';
        //                 }
        //                 if($data->destination_type == NULL){
        //                     $data->destination_type = 'Not Available';
        //                 }else{
        //                     $data->destination_type = ucwords(str_replace('_', ' ', $data->destination_type));
        //                 }
        //                 $data->click_count = ManualNotificationCount::where('manual_id', $data->id)->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($endDate. ' + 1 days'))])->count();
        //                 return $data;
        //             });
        //         }else{
        //             $manuals = ManualNotification::get()->map(function($data){
        //                 if($data->date == NULL){
        //                     $data->notification_type = 'Immidiate';
        //                 }elseif($data->date != NULL){
        //                     $data->notification_type = 'Scheduled';
        //                 }
        //                 if($data->destination_type == NULL){
        //                     $data->destination_type = 'Not Available';
        //                 }else{
        //                     $data->destination_type = ucwords(str_replace('_', ' ', $data->destination_type));
        //                 }
        //                 $data->click_count = ManualNotificationCount::where('manual_id', $data->id)->count();
        //                 return $data;
        //             });
        //         }
        //     }else{
        //         $manuals = ManualNotification::get()->map(function($data){
        //             if($data->date == NULL){
        //                 $data->notification_type = 'Immidiate';
        //             }elseif($data->date != NULL){
        //                 $data->notification_type = 'Scheduled';
        //             }
        //             if($data->destination_type == NULL){
        //                 $data->destination_type = 'Not Available';
        //             }else{
        //                 $data->destination_type = ucwords(str_replace('_', ' ', $data->destination_type));
        //             }
        //             $data->click_count = ManualNotificationCount::where('manual_id', $data->id)->count();
        //             return $data;
        //         });
        //     }
        // }

        return DataTables::of($notificationDetail)
        ->addIndexColumn()
        ->make(true);
    }

    public function getAlertNotifyCount(Request $request)
    {

        $notificationData = [];
        $notificationDetail = [];
        if ($request->ajax()) {
            $data = new NotifyMe();
            $data=$data->where('type','alert');
            if($request->start_date){
                $start_date =  date('Y-m-d', strtotime($request->start_date));
                $data = $data->whereDate('created_at', '>=', $start_date);
            }
            if($request->end_date){
                $end_date =  date('Y-m-d', strtotime($request->end_date));
                $data = $data->whereDate('created_at', '<=', $end_date);
            }
            // $totalCount = $data->where('status',0)->count();
            $data = $data->get()->groupBy('product_id');
            // if($request->start_date != NULL && $request->end_date != NULL){
            //     $data = NotifyMe::where('type', 'alert')->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('product_id');
            // }else{
            //     if($request->start_date != NULL && $request->end_date == NULL){
            //         $data = NotifyMe::where('type', 'alert')->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('product_id');
            //     }elseif($request->end_date != NULL && $request->start_date == NULL){
            //         $date = NotifyMe::where('type', 'alert')->min('created_at');
            //         if($date){
            //             $data = NotifyMe::where('type', 'alert')->get()->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('product_id');
            //         }else{
            //             $data = NotifyMe::where('type', 'alert')->get()->groupBy('product_id');
            //         }
            //     }else{
            //         $data = NotifyMe::where('type', 'alert')->get()->groupBy('product_id');
            //     }
            // }
            foreach ($data as $key => $d) {
                // if ($key != NULL) {
                //     if($request->start_date != NULL && $request->end_date != NULL){
                //         $sent = AlertNotification::where('product_id', $key)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                //     }else{
                //         if($request->start_date != NULL && $request->end_date == NULL){
                //             $sent = AlertNotification::where('product_id', $key)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
                //         }elseif($request->end_date != NULL && $request->start_date == NULL){
                //             $date = AlertNotification::min('created_at');
                //             if($date){
                //                 $sent = AlertNotification::where('product_id', $key)->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                //             }else{
                //                 $sent = AlertNotification::where('product_id', $key)->count();
                //             }
                //         }else{
                //             $sent = AlertNotification::where('product_id', $key)->count();
                //         }
                //     }
                //     $product = Product::where('product_id', $key)->first();
                //     $totalCount = NotifyMe::where('type', 'alert')->where('status', '=', 0)->where('product_id', $key)->count();
                //     $notificationData['product'] = $product != NULL ? $product->title_english : NULL;
                //     $notificationData['count'] = $totalCount;
                //     $notificationData['total_count'] = count($data[$key]);
                //     $notificationData['sent_count'] =  $sent;
                //     $notificationDetail[] = $notificationData;
                // }
                if ($key != NULL) {
                    $sent = new AlertNotification();
                    $active = new NotifyMe();
                    $sent = $sent->where('product_id', $key);
                    $active = $active->where('product_id', $key)->where('type', 'alert');
                    if($request->start_date){
                        $start_date =  date('Y-m-d', strtotime($request->start_date));
                        $sent = $sent->whereDate('created_at', '>=', $start_date);
                        $active = $active->whereDate('created_at', '>=', $start_date);
                    }
                    if($request->end_date){
                        $end_date =  date('Y-m-d', strtotime($request->end_date));
                        $sent = $sent->whereDate('created_at', '<=', $end_date);
                        $active = $active->whereDate('created_at', '<=', $end_date);
                    }
                    $sent = $sent->count();
                    $totalCount = $active->where('status', '=', 0)->count();
                    $product = Product::where('product_id', $key)->first();
                    $notificationData['product'] = $product != NULL ? $product->title_english : NULL;
                    $notificationData['count'] = $totalCount;
                    $notificationData['total_count'] = count($data[$key]);
                    $notificationData['sent_count'] =  $sent;
                    $notificationDetail[] = $notificationData;
                }
            }
            return DataTables::of($notificationDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getRemindNotifyCount(Request $request)
    {
        $notificationData = [];
        $notificationDetail = [];
        if ($request->ajax()) {
            $data = new NotifyMe();
            $data=$data->where('type','remind_me');
            if($request->start_date){
                $start_date =  date('Y-m-d', strtotime($request->start_date));
                $data = $data->whereDate('created_at', '>=', $start_date);
            }
            if($request->end_date){
                $end_date =  date('Y-m-d', strtotime($request->end_date));
                $data = $data->whereDate('created_at', '<=', $end_date);
            }
            // $totalCount = $data->where('status',0)->count();
            $data = $data->get()->groupBy('product_id');
            // $data = NotifyMe::where('type', 'remind_me')->get()->groupBy('product_id');
            // if($request->start_date != NULL && $request->end_date != NULL){
            //     $data = NotifyMe::where('type', 'remind_me')->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('product_id');
            // }else{
            //     if($request->start_date != NULL && $request->end_date == NULL){
            //         $data = NotifyMe::where('type', 'remind_me')->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('product_id');
            //     }elseif($request->end_date != NULL && $request->start_date == NULL){
            //         $date = NotifyMe::where('type', 'remind_me')->min('created_at');
            //         if($date){
            //             $data = NotifyMe::where('type', 'remind_me')->get()->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('product_id');
            //         }else{
            //             $data = NotifyMe::where('type', 'remind_me')->get()->groupBy('product_id');
            //         }
            //     }else{
            //         $data = NotifyMe::where('type', 'remind_me')->get()->groupBy('product_id');
            //     }
            // }
            foreach ($data as $key => $d) {
                // if ($key != NULL) {
                    // if($request->start_date != NULL && $request->end_date != NULL){
                    //     $sent = RemindNotification::where('product_id', $key)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                    // }else{
                    //     if($request->start_date != NULL && $request->end_date == NULL){
                    //         $sent = RemindNotification::where('product_id', $key)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
                    //     }elseif($request->end_date != NULL && $request->start_date == NULL){
                    //         $date = RemindNotification::min('created_at');
                    //         if($date){
                    //             $sent = RemindNotification::where('product_id', $key)->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->count();
                    //         }else{
                    //             $sent = RemindNotification::where('product_id', $key)->count();
                    //         }
                    //     }else{
                    //         $sent = RemindNotification::where('product_id', $key)->count();
                    //     }
                    // }
                //     $product = Product::where('product_id', $key)->first();
                //     $totalCount = NotifyMe::where('type', 'remind_me')->where('status', '=', 0)->where('product_id', $key)->count();
                //     $notificationData['product'] = $product != NULL ? $product->title_english : NULL;
                //     $notificationData['count'] = $totalCount;
                //     $notificationData['total_count'] = count($data[$key]);
                //     $notificationData['sent_count'] =  $sent;
                //     $notificationDetail[] = $notificationData;
                // }
                if ($key != NULL) {
                    $sent = new RemindNotification();
                    $active = new NotifyMe();
                    $sent = $sent->where('product_id', $key);
                    $active = $active->where('product_id', $key)->where('type', 'remind_me');
                    if($request->start_date){
                        $start_date =  date('Y-m-d', strtotime($request->start_date));
                        $sent = $sent->whereDate('created_at', '>=', $start_date);
                        $active = $active->where('status', '=', 0)->whereDate('created_at', '>=', $start_date);
                    }
                    if($request->end_date){
                        $end_date =  date('Y-m-d', strtotime($request->end_date));
                        $sent = $sent->whereDate('created_at', '<=', $end_date);
                        $active = $active->where('status', '=', 0)->whereDate('created_at', '<=', $end_date);
                    }
                    $sent = $sent->count();
                    $totalCount = $active->where('status', '=', 0)->count();
                    $product = Product::where('product_id', $key)->first();
                    $notificationData['product'] = $product != NULL ? $product->title_english : NULL;
                    $notificationData['count'] = $totalCount;
                    $notificationData['total_count'] = count($data[$key]);
                    $notificationData['sent_count'] =  $sent;
                    $notificationDetail[] = $notificationData;
                }
            }
            return DataTables::of($notificationDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getScanProduct(Request $request)
    {
        $scanData = [];
        $scanDetail = [];
        $data = new ScanProductCount();
        $data = $data->where('product_id', '!=', NULL);
        if($request->start_date){
            $start_date =  date('Y-m-d', strtotime($request->start_date));
            $data = $data->whereDate('created_at', '>=', $start_date);
        }
        if($request->end_date){
            $end_date =  date('Y-m-d', strtotime($request->end_date));
            $data = $data->whereDate('created_at', '<=', $end_date);
        }
        $data = $data->get()->groupBy('product_id');
        // $scanData = [];
        // $scanDetail = [];
        // if($request->start_date != NULL && $request->end_date != NULL){
        //     $data = ScanProductCount::where('product_id', '!=', NULL)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->get()->groupBy('product_id');
        // }else{
        //     if($request->start_date != NULL && $request->end_date == NULL){
        //         $data = ScanProductCount::where('product_id', '!=', NULL)->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->get()->groupBy('product_id');
        //     }elseif($request->end_date != NULL && $request->start_date == NULL){
        //         $date = ScanProductCount::min('created_at');
        //         if($date){
        //             $data = ScanProductCount::where('product_id', '!=', NULL)->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->get()->groupBy('product_id');
        //         }else{
        //             $data = ScanProductCount::where('product_id', '!=', NULL)->get()->groupBy('product_id');
        //         }
        //     }else{
        //         $data = ScanProductCount::where('product_id', '!=', NULL)->get()->groupBy('product_id');
        //     }
        // }
        
        foreach ($data as $key => $detail) {
            if ($key != NULL) {
                $product = Product::where('product_id', $key)->first();
                $scanData['product'] = $product != NULL ? $product->title_english : NULL;
                $scanData['scan_correct'] = 0;
                $scanData['card_open'] = 0;
                $scanData['detail_page'] =  0;
                $scanData['share'] =  0;
;
                foreach ($detail as $d) {
                    if ($d->name == 'scan_correct') {
                        // $scanData['scan_correct'] = $data[];
                        $scanData['scan_correct'] = $scanData['scan_correct'] + 1;
                        // $scanData['scan_correct'] = ScanProductCount::where('product_id',  $product->product_id)->where('name', 'scan_correct')->count();
                    } elseif ($d->name == 'card_open') {
                        $scanData['card_open'] = $scanData['card_open'] + 1;
                        // $scanData['card_open'] = ScanProductCount::where('product_id', $product->product_id)->where('name', 'card_open')->count();
                    } elseif ($d->name == 'detail_page') {
                        $scanData['detail_page'] = $scanData['detail_page'] + 1;
                        // $scanData['detail_page'] =  ScanProductCount::where('product_id', $product->product_id)->where('name', 'detail_page')->count();
                    } elseif ($d->name == 'share') {
                        $scanData['share'] = $scanData['share'] + 1;
                        // $scanData['share'] =  ScanProductCount::where('product_id', $product->product_id)->where('name', 'share')->count();
                    }
                }
                $scanDetail[] = $scanData;
            }
        }
        if ($request->ajax()) {
            // $data = ScanProductCount::where('product_id', '!=', NULL)->get()->map(function ($detail) {
            //     $productValue         = Product::where('product_id', $detail->product_id)->first();
            //     $detail->product      = $productValue->title_english;
            //     $detail->scan_count   = $detail->scan_correct;
            //     return $detail;
            // });
            return DataTables::of($scanDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getViewProduct(Request $request)
    {
        $viewData = [];
        $viewDetail = [];
        $data = new ViewProductCount();
        if ($request->start_date) {
            $startDate = date('Y-m-d', strtotime($request->start_date));
            $data = $data->whereDate('created_at', '>=',$startDate);
        }
        if ($request->end_date) {
            $endDate = date('Y-m-d', strtotime($request->end_date));
            $data = $data->whereDate('created_at', '<=',$endDate);
        }
        $data = $data->get()->groupBy('product_id');
        foreach ($data as $key => $detail) {
            if ($key != NULL) {
                $product = Product::where('product_id', $key)->first();
                $viewData['product'] = $product != NULL ? $product->title_english : NULL;
                $viewData['banner'] = 0;
                $viewData['search_page'] = 0;
                $viewData['notification'] =  0;
                $viewData['normal_collection'] =  0;
                $viewData['collection_by_goal'] = 0;
                $viewData['exclusive_banner'] = 0;
                $viewData['recommend_section'] = 0;
                $viewData['explore_page'] = 0;
                $viewData['how_to_use'] = 0;
                $viewData['review'] = 0;
                $viewData['share_product'] = 0;
                $viewData['add_to_cart'] = 0;
                foreach ($detail as $d) {
                    if ($d->name == 'banner') {
                        $viewData['banner'] = $viewData['banner'] + 1;
                    } elseif ($d->name == 'search_page') {
                        $viewData['search_page'] = $viewData['search_page'] + 1;
                    } elseif ($d->name == 'notification') {
                        $viewData['notification'] =  $viewData['notification'] + 1;
                    } elseif ($d->name == 'normal_collection') {
                        $viewData['normal_collection'] =  $viewData['normal_collection'] + 1;
                    } elseif ($d->name == 'collection_by_goal') {
                        $viewData['collection_by_goal'] = $viewData['collection_by_goal'] + 1;
                    } elseif ($d->name == 'exclusive_banner') {
                        $viewData['exclusive_banner'] = $viewData['exclusive_banner'] + 1;
                    } elseif ($d->name == 'recommend_section') {
                        $viewData['recommend_section'] =  $viewData['recommend_section'] + 1;
                    } elseif ($d->name == 'explore_page') {
                        $viewData['explore_page'] =  $viewData['explore_page'] + 1;
                    }
                    elseif ($d->name == 'how_to_use') {
                        $viewData['how_to_use'] = $viewData['how_to_use'] + 1;
                    } elseif ($d->name == 'review') {
                        $viewData['review'] = $viewData['review'] + 1;
                    } elseif ($d->name == 'share_product') {
                        $viewData['share_product'] = $viewData['share_product'] + 1;
                    } elseif ($d->name == 'add_to_cart') {
                        $viewData['add_to_cart'] = $viewData['add_to_cart'] + 1;
                    }
                }
                $viewDetail[] = $viewData;
            }
        }
        if ($request->ajax()) {
            return DataTables::of($viewDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getViewCollection(Request $request)
    {
        $viewData = [];
        $viewDetail = [];
        $data = new ViewCollectionCount();
        if ($request->start_date) {
            $startDate = date('Y-m-d', strtotime($request->start_date));
            $data = $data->whereDate('created_at', '>=',$startDate);
        }
        if ($request->end_date) {
            $endDate = date('Y-m-d', strtotime($request->end_date));
            $data = $data->whereDate('created_at', '<=',$endDate);
        }
        $data = $data->get()->groupBy('collection_id');
        
        foreach ($data as $key => $detail) {
            if ($key != NULL) {
                $collection = Collection::where('collection_id', $key)->first();
                $viewData['collection'] = $collection != NULL ? $collection->title_english : NULL;
                $viewData['banner'] = 0;
                $viewData['search_page'] = 0;
                $viewData['notification'] =  0;
                $viewData['normal_collection'] =  0;
                $viewData['collection_by_goal'] = 0;
                foreach ($detail as $d) {
                    if ($d->name == 'banner') {
                        $viewData['banner'] = $viewData['banner'] + 1;
                    } elseif ($d->name == 'search_page') {
                        $viewData['search_page'] =  $viewData['search_page'] + 1;
                    } elseif ($d->name == 'notification') {
                        $viewData['notification'] =  $viewData['notification'] + 1;
                    } elseif ($d->name == 'normal_collection') {
                        $viewData['normal_collection'] =  $viewData['normal_collection'] + 1;
                    } elseif ($d->name == 'collection_by_goal') {
                        $viewData['collection_by_goal'] = $viewData['collection_by_goal'] + 1;
                    }
                }
                $viewDetail[] = $viewData;
            }
        }
        if ($request->ajax()) {
            return DataTables::of($viewDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getFaq(Request $request)
    {
        // $startDate = $request->start_date;
        // $endDate = $request->end_date;
        $faqData = [];
        $faqDetail = [];
        if ($request->ajax()) {

            // $data = new CategoryFAQ();
            // if($request->start_date){
            //     $start_date =  date('Y-m-d', strtotime($request->start_date));
            //     $data = $data->whereDate('created_at', '>=', $start_date);
            // }
            // if($request->end_date){
            //     $end_date =  date('Y-m-d', strtotime($request->end_date));
            //     $data = $data->whereDate('created_at', '<=', $end_date);
            // }
            // $data = $data->select('id', 'question_english as question', 'count')->get();
            // $data = CategoryFAQ::select('id', 'question_english as question', 'count')->get();

            // if($request->start_date != NULL && $request->end_date != NULL){
            //     $data = CategoryFAQ::select('id', 'question_english as question', 'count')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->get()->map(function($detail) use ( $startDate, $endDate){
            //         $detail->count = FaqClickCount::where('faq_id', $detail->id)->whereBetween('created_at', [date('Y-m-d', strtotime($startDate. ' - 1 days')),date('Y-m-d', strtotime($endDate. ' + 1 days'))])->count();
            //         return $detail;
            //     });
            // }else{
            //     if($request->start_date != NULL && $request->end_date == NULL){
            //         $data = CategoryFAQ::select('id', 'question_english as question', 'count')->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->get()->map(function($detail) use ( $startDate){
            //             $detail->count = FaqClickCount::where('faq_id', $detail->id)->whereBetween('created_at', [date('Y-m-d', strtotime($startDate. ' - 1 days')),date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->count();
            //             return $detail;
            //         });
            //     }elseif($request->end_date != NULL && $request->start_date == NULL){
            //         $date = CategoryFAQ::min('created_at');
            //         if($date){
            //             $input = strtotime($date); 
            //             $only_start =  date('Y-m-d ', $input);
            //             $data = CategoryFAQ::select('id', 'question_english as question', 'count')->whereBetween('created_at', [$only_start, $request->end_date])->get()->map(function($detail) use ($date,$endDate){
            //                 $detail->count = FaqClickCount::where('faq_id', $detail->id)->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')),date('Y-m-d', strtotime($endDate. ' + 1 days'))])->count();
            //                 return $detail;
            //             });
            //         }else{
            //             $data = CategoryFAQ::select('id', 'question_english as question', 'count')->get()->map(function($detail){
            //                 $detail->count = FaqClickCount::where('faq_id', $detail->id)->count();
            //                 return $detail;
            //             });
            //         }
            //     }else{
            //         $data = CategoryFAQ::select('id', 'question_english as question', 'count')->get()->map(function($detail){
            //             $detail->count = FaqClickCount::where('faq_id', $detail->id)->count();
            //             return $detail;
            //         });
            //     }
            // }
            
            $clickObj = new FaqClickCount();

            if($request->start_date){
                $start_date =  date('Y-m-d', strtotime($request->start_date));
                $clickObj = $clickObj->whereDate('created_at', '>=', $start_date);
            }
            if($request->end_date){
                $end_date =  date('Y-m-d', strtotime($request->end_date));
                $clickObj = $clickObj->whereDate('created_at', '<=', $end_date);
            }
            $data = $clickObj->get()->groupBy('faq_id');
            foreach ($data as $key => $value) {
                // $countTotal = $clickObj->count();
                if($key != NULL){
                    $faq = CategoryFAQ::where('id',$key )->first();
                    $faqData['question'] =  $faq != NULL ? $faq->question_english : '';
                    $faqData['count'] =  count($value);
                    $faqDetail[] = $faqData;
                }
            }
            return DataTables::of($faqDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    // public function getCheckoutCount(Request $request)
    // {
    //     if ($request->ajax()) {
    //         $data = CheckoutStepCount::latest()->get();
    //         return DataTables::of($data)
    //             ->addIndexColumn()
    //             ->make(true);
    //     }
    // }

    public function getAllSearchTerm(Request $request)
    {
        if ($request->ajax()) {
            $searchData = [];
            $searchDetail = [];
            $data = new SearchTerm();
            // $data = $data->where('product_id', '!=', NULL);
            if($request->start_date){
                $start_date =  date('Y-m-d', strtotime($request->start_date));
                $data = $data->whereDate('created_at', '>=', $start_date);
            }
            if($request->end_date){
                $end_date =  date('Y-m-d', strtotime($request->end_date));
                $data = $data->whereDate('created_at', '<=', $end_date);
            }
            $data = $data->latest()->get()->groupBy('name');
            // if($request->start_date != NULL && $request->end_date != NULL){
            //     $data = SearchTerm::latest()->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('name');
            // }else{
            //     if($request->start_date != NULL && $request->end_date == NULL){
            //         $data = SearchTerm::latest()->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('name');
            //     }elseif($request->end_date != NULL && $request->start_date == NULL){
            //         $date = SearchTerm::min('created_at');
            //         if($date){
            //             $data = SearchTerm::latest()->get()->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('name');
            //         }else{
            //             $data = SearchTerm::latest()->get()->groupBy('name');
            //         }
            //     }else{
            //         $data = SearchTerm::latest()->get()->groupBy('name');
            //     }
            // }
            foreach ($data as $key => $value) {
                if ($key != NULL) {
                    $searchData['name'] =  $key;
                    $searchData['count'] = count($data[$key]) != NULL ? count($data[$key]) : 0;
                    $searchDetail[] = $searchData;
                }
            }
            return DataTables::of($searchDetail)
                ->addIndexColumn()
                ->make(true);
        }
    }

    public function getRemoveCartCount(Request $request)
    {
        if ($request->ajax()) {
            $final_cart = [];
            $remove_cart_data = [];
            $cart = new Cart();
            $cart = $cart->where('is_delete', 1);
            if($request->start_date){
                $start_date =  date('Y-m-d', strtotime($request->start_date));
                $cart = $cart->whereDate('created_at', '>=', $start_date);
            }
            if($request->end_date){
                $end_date =  date('Y-m-d', strtotime($request->end_date));
                $cart = $cart->whereDate('created_at', '<=', $end_date);
            }
            $cart = $cart->get()->groupBy('product_id');

            // if($request->start_date != NULL && $request->end_date != NULL){
            //     $cart = Cart::where('is_delete', 1)->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')),date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('product_id');
            // }else{
            //     if($request->start_date != NULL && $request->end_date == NULL){
            //         $cart = Cart::where('is_delete', 1)->get()->whereBetween('created_at', [date('Y-m-d', strtotime($request->start_date. ' - 1 days')), date('Y-m-d', strtotime(now()->format('Y-m-d'). ' + 1 days'))])->groupBy('product_id');
            //     }elseif($request->end_date != NULL && $request->start_date == NULL){
            //         $date = SearchTerm::min('created_at');
            //         if($date){
            //             $cart = Cart::where('is_delete', 1)->get()->whereBetween('created_at', [date('Y-m-d', strtotime($date. ' - 1 days')), date('Y-m-d', strtotime($request->end_date. ' + 1 days'))])->groupBy('product_id');
            //         }else{
            //             $cart = Cart::where('is_delete', 1)->get()->groupBy('product_id');
            //         }
            //     }else{
            //         $cart = Cart::where('is_delete', 1)->get()->groupBy('product_id');
            //     }
            // }
            // $cart = Cart::where('is_delete', 1)->get()->groupBy('product_id');
            foreach ($cart as $key => $value) {
                if ($key != NULL) {
                    $product = Product::where('product_id', $key)->first();
                    $final_cart['product'] =  $product ? $product->title_english : "";
                    // $final_cart['count'] = count($cart[$key]) != NULL ? count($cart[$key]) : 0;
                    $final_cart['count'] =  count($value);
                    $remove_cart_data[] = $final_cart;
                }
            }
            return DataTables::of($remove_cart_data)
                ->addIndexColumn()
                ->make(true);
        }
    }
    public function export()
    {
        return Excel::download(new AnalyticExport, 'analytic.xlsx');
    }
    public function exportCurrency()
    {
        return Excel::download(new CurrencyExport, 'currencycount.xlsx');
    }
    public function exportAddToCart()
    {
        return Excel::download(new AddToCartExport, 'add_to_cart.xlsx');
    }
    public function exportMilestone()
    {
        return Excel::download(new MilestoneCountExport, 'milestonecount.xlsx');
    }
    public function exportScanProduct()
    {
        return Excel::download(new ProductScanCountExport, 'scanproduct.xlsx');
    }
    public function orderFromExport()
    {
        return Excel::download(new OrderFromExport, 'order_from.xlsx');
    }
    public function alertSentExport()
    {
        return Excel::download(new AlertNotificationExport, 'alert_sent.xlsx');
    }
    public function remindSentExport()
    {
        return Excel::download(new RemindSentExport, 'remind_sent.xlsx');
    }
    public function exportIntro()
    {
        return Excel::download(new IntroExport, 'intro.xlsx');
    }
    public function exportCheckoutStep()
    {
        return Excel::download(new CheckoutStepExport, 'checkout_step.xlsx');
    }
    public function exportMenuList()
    {
        return Excel::download(new MenuListExport, 'menu_list.xlsx');
    }
    public function exportViewProduct()
    {
        return Excel::download(new ViewProductExport, 'view_product.xlsx');
    }
    public function exportViewCollection()
    {
        return Excel::download(new ViewCollectionExport, 'view_collection.xlsx');
    }
    public function exportProductDetail()
    {
        return Excel::download(new ProductDetailCount, 'product_details.xlsx');
    }
    public function exportSearchTerm()
    {
        return Excel::download(new SearchTermExport, 'search_term.xlsx');
    }
    public function exportFaq()
    {
        return Excel::download(new FaqExport, 'faq.xlsx');
    }
    public function exportNotificationSent()
    {
        return Excel::download(new ManualNotificationExport, 'manual_notification.xlsx');
    }
    public function exportRemoveCart()
    {
        return Excel::download(new RemoveCartExport, 'remove_cart.xlsx');
    }

    public function dateChange(Request $request){
        $menuDetail         = MenuClickCount::get()->groupBy('menu');
        echo "<pre>";
        print_r($menuDetail->toarray());die;
        // $english = UserToken::where('language_id', 'en')->whereDate('created_at', '>', Carbon::now())->count();
        // echo $english;die;
        $startDate = '2022-01-05';
        $endDate = '2022-01-06';
        // echo date('Y-m-d', strtotime($startDate));die;
        $start_date =  date('Y-m-d', strtotime($startDate));
        $end_date =  date('Y-m-d', strtotime($endDate));
        $obj = new ExclusiveViewAll();
        $obj = $obj->whereDate('created_at', '<=', $start_date)->count();
        echo $obj;die;
        echo ExclusiveViewAll::whereDate('created_at', '>', Carbon::now())->count();die;
        echo Carbon::now();die;
        // echo Carbon::now('Asia/Kuwait');die;

        echo "<pre>";
        // print_r($manuals->toArray());die;
        ExclusiveViewAll::insert([
            'count'       => 1,
            'created_at' => Carbon::now('Asia/Kuwait'),
            'updated_at' => Carbon::now('Asia/Kuwait')
        ]);
    }
}
