<?php

namespace App\Http\Controllers\Admin\AppSetting\Notification;

use Response;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DataTables;
use App\Models\NotifyMe;

class NotificationController extends Controller
{

    public function __construct()
    {
    }

    public function index()
    {
        return view('admin.app-setting.notification.notification');
    }

    public function getAllNotification(Request $request)
    {
        if ($request->ajax()) {
            $data = NotifyMe::where('status', 0)->with(['variant' => function ($query) {
                $query->with('product');
            }])->latest()->get();
            return Datatables::of($data)
                ->addIndexColumn()
                ->addColumn('action', function ($row) {
                    $btn = '<a href="javascript:void(0)" class="delete btn btn-danger btn-sm ml-2" data-id="' . $row->id . '">Delete</a>';
                    return $btn;
                })
                ->addColumn('product', function ($row) {
                    $variant = "";
                    $product = "";
                    if ($row->variant->option1_english) {
                        $variant = $row->variant->option1_english;
                    }
                    if ($row->variant->option2_english) {
                        $variant = $variant . '/' . $row->variant->option2_english;
                    }
                    if ($row->variant->option3_english) {
                        $variant = $variant . '/' . $row->variant->option3_english;
                    }
                    $product = $row->variant->product->title_english;
                    if ($variant != 'Default Title') {
                        $product = $product . '(' . $variant . ')';
                    }
                    return $product;
                })
                ->rawColumns(['action'])

                ->make(true);
        }
    }

    public function delete(Request $request)
    {
        $notification = NotifyMe::where('id', $request->id)->delete();
        return response()->json([
            'success' => true,
            'msg' => 'Record deleted successfully.'
        ]);
    }
}
