<?php

namespace App\Http\Controllers\Admin\AppSetting\Variant;

use App\Http\Controllers\Controller;
use App\Models\Variant;
use Illuminate\Http\Request;

class VariantController extends Controller
{
    public function getProductVariants(Request $request)
    {
        $variants = Variant::where('product_id', $request->product_id)->get();
        foreach ($variants as $bs) {
            $bs['error'] = array("option1_english" => "", "option1_arabic" => "", "option2_english" => "", "option2_arabic" => "", "option3_english" => "", "option3_arabic" => "");
        }
        return response()->json([
            'success' => true,
            'variants' => $variants
        ]);
    }

    public function updateVariants(Request $request)
    {
        $variantDetails = $request->variant;
        foreach ($variantDetails as $variant) {
            if (isset($variant['id'])) {
                Variant::where('id', $variant['id'])->update([
                    'option1_arabic'    => !empty($variant["option1_arabic"]) ? $variant["option1_arabic"] : NULL,
                    'option2_arabic'    => !empty($variant["option2_arabic"]) ? $variant["option2_arabic"] : NULL,
                    'option3_arabic'    => !empty($variant["option3_arabic"]) ? $variant["option3_arabic"] : NULL,
                    'status' => $variant['status']
                ]);
            }
        }
        $variants = Variant::where('product_id', $request->product_id)->get();
        foreach ($variants as $bs) {
            $bs['error'] = array("option1_english" => "", "option1_arabic" => "", "option2_english" => "", "option2_arabic" => "", "option3_english" => "", "option3_arabic" => "");
        }
        return response()->json([
            'success' => true,
            'variants' => $variants,
            'msg' => 'Record saved successfully.'
        ]);
    }
}
