<?php

namespace App\Http\Controllers\Api\AppSetting;

use App\Exports\ViewProductExport;
use Response;
use Validator;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\AlertNotification;
use App\Models\IntroSkip;
use App\Models\MenuClickCount;
use App\Models\ProductDetailsCount;
use App\Models\RemindNotification;
use App\Models\ScanProductCount;
use App\Models\Variant;
use App\Models\ViewCollectionCount;
use App\Models\CheckoutStepCount;
use App\Models\DeviceOrderFrom;
use App\Models\CategoryFAQ;
use App\Models\FaqClickCount;
use App\Models\ManualNotification;
use App\Models\ManualNotificationCount;
use App\Models\ViewProductCount;
use Carbon\Carbon;

class AnalyticController extends Controller
{

    public function checkSkipStep(Request $request)
    {
        // $intro_step = IntroSkip::where('step', $request->step)->first();
        // if ($intro_step) {
        //     IntroSkip::where('step', $request->step)->update([
        //         'count' => $intro_step->count + 1
        //     ]);
        // } else {
        //     IntroSkip::create([
        //         'step' => $request->step,
        //         'count' => 1
        //     ]);
        // }
        // IntroSkip::create([
        //     'step' => $request->step,
        //     'count' => 1,
        //     'created_at' => Carbon::now('Asia/Kuwait'),
        //     'updated_at' => Carbon::now('Asia/Kuwait')
        // ]);

        IntroSkip::insert([
            'step' => $request->step,
            'count' => 1,
            'created_at' => Carbon::now('Asia/Kuwait'),
            'updated_at' => Carbon::now('Asia/Kuwait')
        ]);

        return response()->json([
            'success' => true
        ]);
    }
    public function checkMenuClickCount(Request $request)
    {
        // $click_menu = MenuClickCount::where('menu', $request->menu)->first();
        // if ($click_menu) {
        //     MenuClickCount::where('menu', $request->menu)->update([
        //         'count' => $click_menu->count + 1
        //     ]);
        // } else {
        //     MenuClickCount::create([
        //         'menu' => $request->menu,
        //         'count' => 1
        //     ]);
        // }
        if($request->menu != NULL){
            MenuClickCount::insert([
                'menu' => trim($request->menu),
                'count' => 1,
                'created_at' => Carbon::now('Asia/Kuwait'),
                'updated_at' => Carbon::now('Asia/Kuwait')
            ]);
        }
        return response()->json([
            'success' => true
        ]);
    }

    public function checkViewCount(Request $request)
    {
        if($request->type == 'product'){
            // $exist = ViewProductCount::where('name', $request->name)->first();
            // if ($exist) {
            //     ViewProductCount::where('name', $request->name)->update([
            //         'count' => $exist->count + 1
            //     ]);
            // } else {
            //     ViewProductCount::create([
            //         'name' => $request->name,
            //         'count' => 1
            //     ]);
            // }
            ViewProductCount::create([
                'name' => $request->name,
                'count' => 1
            ]);
            return response()->json([
                'success' => true
            ]);

        }elseif($request->type == 'collection'){
            // $exist = ViewCollectionCount::where('name', $request->name)->first();
            // if ($exist) {
            //     ViewCollectionCount::where('name', $request->name)->update([
            //         'count' => $exist->count + 1
            //     ]);
            // } else {
            //     ViewCollectionCount::create([
            //         'name' => $request->name,
            //         'count' => 1
            //     ]);
            // }
            ViewCollectionCount::create([
                'name' => $request->name,
                'count' => 1
            ]);
            return response()->json([
                'success' => true
            ]);
        }
    }

    public function checkCollectionViewCount(Request $request)
    {
        // $exist = ViewCollectionCount::where('collection_id', $request->collection_id)->where('name', $request->name)->first();
        // if ($exist) {
        //     ViewCollectionCount::where('id', $exist->id)->update([
        //         'count' => $exist->count + 1
        //     ]);
        // } else {
        //     ViewCollectionCount::create([
        //         'collection_id' => $request->collection_id,
        //         'name'          => $request->name,
        //         'count'         => 1
        //     ]);
        // }
        ViewCollectionCount::insert([
            'collection_id' => $request->collection_id,
            'name'          => $request->name,
            'count'         => 1,
            'created_at'    => Carbon::now('Asia/Kuwait'),
            'updated_at'    => Carbon::now('Asia/Kuwait')
        ]);
        return response()->json([
            'success' => true
        ]);
    }

    public function checkProductViewCount(Request $request)
    {
        // $exist = ViewProductCount::where('product_id', $request->product_id)->where('name', $request->name)->first();
        // if ($exist) {
        //     ViewProductCount::where('id', $exist->id)->update([
        //         'count' => $exist->count + 1
        //     ]);
        // } else {
        //     ViewProductCount::create([
        //         'product_id' => $request->product_id,
        //         'name'          => $request->name,
        //         'count'         => 1
        //     ]);
        // }
        ViewProductCount::insert([
            'product_id'    => $request->product_id,
            'name'          => $request->name,
            'count'         => 1,
            'created_at'    => Carbon::now('Asia/Kuwait'),
            'updated_at'    => Carbon::now('Asia/Kuwait')
        ]);
        return response()->json([
            'success' => true
        ]);
    }

    public function sentNotificationCount(Request $request){
        if($request->type == 'alert'){
            $product_id = NULL;
            $variant = Variant::where('variant_id', $request->variant_id)->first();
            if($variant){
                $product_id = $variant->product_id;
                // $exist = AlertNotification::where('product_id', $product_id)->first();
                // if ($exist) {
                //     AlertNotification::where('product_id', $exist->product_id)->update(
                //         [
                //             'sent_count'  => $exist->sent_count + 1,
                //         ]
                //     );
                // }else{
                //     AlertNotification::create(
                //         [
                //             'product_id'  => $product_id,
                //             'sent_count'  => 1,
                //         ]
                //     );
                // }
                AlertNotification::insert(
                    [
                        'product_id'  => $product_id,
                        'sent_count'  => 1,
                        'created_at'    => Carbon::now('Asia/Kuwait'),
                        'updated_at'    => Carbon::now('Asia/Kuwait')
                    ]
                );
            }
            
            return response()->json([
                'success' => true
            ]);

        }elseif($request->type == 'remind_me'){
            $productId = Variant::where('variant_id', $request->variant_id)->first();
            if($productId){
                // $remindNotifyExist = RemindNotification::where('product_id', $productId->product_id)->first();
                // if ($remindNotifyExist) {
                //     RemindNotification::where('id', $remindNotifyExist->id)->update(
                //         [
                //             'sent_count'  => $remindNotifyExist->sent_count + 1,
                //         ]
                //     );
                // }else{
                //     RemindNotification::create(
                //         [
                //             'product_id'  => $productId->product_id,
                //             'sent_count'  => 1,
                //         ]
                //     );
                // }
                RemindNotification::insert(
                    [
                        'product_id'  => $productId->product_id,
                        'sent_count'  => 1,
                        'created_at'    => Carbon::now('Asia/Kuwait'),
                        'updated_at'    => Carbon::now('Asia/Kuwait')
                    ]
                );
                return response()->json([
                    'success' => true
                ]);
            }
        }elseif($request->type == 'manual'){
            $manual = ManualNotification::where('id', $request->manual_id)->first();
            if($manual){
                ManualNotificationCount::insert(
                    [
                        'manual_id'     => $request->manual_id,
                        'created_at'    => Carbon::now('Asia/Kuwait'),
                        'updated_at'    => Carbon::now('Asia/Kuwait')
                    ]
                );
                return response()->json([
                    'success' => true
                ]);
            }
        }
    }

    public function productDetailCount(Request $request)
    {
        // $exist = ProductDetailsCount::where('product_id', $request->product_id)->where('name', $request->name)->first();
        // if ($exist) {
        //     ProductDetailsCount::where('id', $exist->id)->update([
        //         'count' => $exist->count + 1
        //     ]);
        // } else {
        //     ProductDetailsCount::create([
        //         'product_id' => $request->product_id,
        //         'name'       => $request->name,
        //         'count'      => 1
        //     ]);
        // }
        // return response()->json([
        //     'success' => true
        // ]);

        // $exist = ViewProductCount::where('product_id', $request->product_id)->where('name', $request->name)->first();
        // if ($exist) {
        //     ViewProductCount::where('id', $exist->id)->update([
        //         'count' => $exist->count + 1
        //     ]);
        // } else {
        //     ViewProductCount::create([
        //         'product_id' => $request->product_id,
        //         'name'       => $request->name,
        //         'count'      => 1
        //     ]);
        // }
        ViewProductCount::insert([
            'product_id' => $request->product_id,
            'name'       => $request->name,
            'count'      => 1,
            'created_at' => Carbon::now('Asia/Kuwait'),
            'updated_at' => Carbon::now('Asia/Kuwait')
        ]);
        return response()->json([
            'success' => true
        ]);
    }

    public function explorePageCount(Request $request)
    {
        // $exist = ScanProductCount::where('product_id', $request->product_id)->first();
        // if($exist){
        //     if ($request->name == 'card_open') {
        //         ScanProductCount::where('product_id', $request->product_id)->update([
        //             'open_card_count' => $exist->open_card_count + 1
        //         ]);
        //     }elseif($request->name == 'detail_page') {
        //         ScanProductCount::where('product_id', $request->product_id)->update([
        //             'detail_page_count' => $exist->detail_page_count + 1
        //         ]);
        //     }elseif($request->name == 'share') {
        //         ScanProductCount::where('product_id', $request->product_id)->update([
        //             'share_count' => $exist->share_count + 1
        //         ]);
        //     }
        // }
        ScanProductCount::insert([
            'product_id' => $request->product_id,
            'name'       => $request->name,
            'created_at' => Carbon::now('Asia/Kuwait'),
            'updated_at' => Carbon::now('Asia/Kuwait')
        ]);
        return response()->json([
            'success' => true
        ]);
    }

    public function faqOpenQuestionCount(Request $request)
    {
        $faq = CategoryFAQ::where('id', $request->id)->first();
        if ($faq) {
            // CategoryFAQ::where('id', $request->id)->update([
            //     'count' => $faq->count + 1
            // ]);
            FaqClickCount::insert([
                'faq_id'     => $request->id,
                'created_at' => Carbon::now('Asia/Kuwait'),
                'updated_at' => Carbon::now('Asia/Kuwait')
            ]);
        }
        return response()->json([
            'success' => true
        ]);
    }
    public function checkoutStepCount(Request $request)
    {
        // $step = CheckoutStepCount::where('step', $request->step)->first();
        // if ($step) {
        //     CheckoutStepCount::where('step', $request->step)->update([
        //         'count' => $step->count + 1
        //     ]);
        // } else {
        //     CheckoutStepCount::create([
        //         'step' => $request->step,
        //         'count' => 1
        //     ]);
        // }
        CheckoutStepCount::insert([
            'step'          => $request->step,
            'count'         => 1,
            'created_at'    => Carbon::now('Asia/Kuwait'),
            'updated_at'    => Carbon::now('Asia/Kuwait')
        ]);
        return response()->json([
            'success' => true
        ]);
    }
    public function deviceOrderCount(Request $request)
    {
        // $device = DeviceOrderFrom::where('from', $request->from)->first();
        // if ($device) {
        //     DeviceOrderFrom::where('from', $request->from)->update([
        //         'count' => $device->count + 1
        //     ]);
        // } else {
        //     DeviceOrderFrom::create([
        //         'from' => $request->from,
        //         'count' => 1
        //     ]);
        // }
        DeviceOrderFrom::insert([
            'from' => $request->from,
            'count' => 1,
            'created_at'    => Carbon::now('Asia/Kuwait'),
            'updated_at'    => Carbon::now('Asia/Kuwait')
        ]);
        return response()->json([
            'success' => true
        ]);
    }
}
