<?php

namespace App\Http\Controllers\Api\AppSetting;

use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\CategoryFAQ;
use Illuminate\Http\Request;
use Response;
use GuzzleHttp\Client;

class CategoryController extends Controller
{
    public $client;
    public function __construct()
    {
        $this->client = new Client();
    }

    public function getCategoryDetail(Request $request)
    {
        $all_title = $request->language_id == 'en' ? 'All' : 'الجميع';
        $all_data = array(
            'id' => 0,
            'title' => $all_title,
            'faq' => []
        );
        $faq = CategoryFAQ::orderBy('display_order', 'asc')->get();
        foreach ($faq as $f) {
            $all_data['faq'][] = array('id' => $f->id, 'category_id' => $f->category_id, 'question' => $request->language_id == 'en' ? $f->question_english : $f->question_arabic, 'answer' => $request->language_id == 'en' ? $f->answer_english : $f->answer_arabic);
        }
        if ($request->language_id == 'en') {
            $category = Category::with(['faq' => function ($query) {
                $query->select('id', 'category_id', 'question_english as question', 'answer_english as answer')
                    ->orderBy('display_order', 'asc');
            }])->orderBy('display_order', 'asc')->select('id', 'title_english as title')->get()->toArray();
        } else if ($request->language_id == 'ar') {
            $category = Category::with(['faq' => function ($query) {
                $query->select('id', 'category_id', 'question_arabic as question', 'answer_arabic as answer')
                    ->orderBy('display_order', 'asc');
            }])->orderBy('display_order', 'asc')->select('id', 'title_arabic as title')->get()->toArray();
        }
        array_splice($category, 0, 0, array($all_data));

        $data = $this->changeString($category);
        return response()->json([
            'success' => true,
            'category' => $data
        ]);
    }

    public function changeString($category)
    {
        $data = $category;
        foreach ($data as $key => $cat_data) {
            foreach ($cat_data['faq'] as $index => $value) {
                $url = '/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/';
                $string = preg_replace($url, '<a href="$0" target="_blank" title="$0" style="color:blue;">$0</a>', $value['answer']);
                $data[$key]['faq'][$index]['answer'] = $string;
            }
        }
        return $data;
    }
}
