<?php

namespace App\Http\Controllers\Api\AppSetting;

use App\Http\Controllers\Admin\Helper\HelperController;
use Response;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\CollectionByGoal;
use GuzzleHttp\Client;
use App\Models\FlashSale;
use App\Models\Product;
use App\Models\ExclusiveSection;
use App\Models\NormalCollection;
use App\Models\Variant;
use App\Models\CollectionProduct;
use App\Models\ExclusiveViewAll;
use App\Models\UserToken;
use App\Models\Wishlist;
use Carbon\Carbon;

class CollectionController extends Controller
{
    public $client;
    public function __construct()
    {
        $this->client = new Client();
    }

    public function getAllCollection(Request $request)
    {
        $collection  = [];
        $all_title = $request->language_id == 'en' ? 'All' : 'الجميع';
        if ($request->type == "collection_by_goal" || $request->type == "normal_collection") {
            if ($request->type == "collection_by_goal") {
                $collection[] = array('id' => 0, 'title' => $all_title, 'type' => 'collection_by_goal');
            } else {
                $collection[] = array('id' => 0, 'title' => $all_title, 'type' => 'normal_collection');
            }
        }

        $now = date('Y-m-d');
        $now_time = date('H:i:s');
        $flash_id = 0;
        $flash_name = "";
        $flash = FlashSale::where('start_date', '<=', $now)->get();
        foreach ($flash as $key => $f) {
            if ($f->status) {
                if ($f->start_date == $now) {
                    if ($f->start_time <= $now_time) {
                        if ($f->end_date >= $now) {
                            if ($f->end_date == $now) {
                                if ($f->end_time >= $now_time) {
                                    $flash_id = $f->id;
                                    $flash_name = $f;
                                    break;
                                }
                            } else {
                                $flash_id = $f->id;
                                $flash_name = $f;
                                break;
                            }
                        }
                    }
                } else {
                    if ($f->end_date >= $now) {
                        if ($f->end_date == $now) {
                            if ($f->end_time >= $now_time) {
                                $flash_id = $f->id;
                                $flash_name = $f;
                                break;
                            }
                        } else {
                            $flash_id = $f->id;
                            $flash_name = $f;
                            break;
                        }
                    }
                }
            } else {
                if ($f->start_date == $now) {
                    if ($f->start_time <= $now_time) {
                        $flash_id = $f->id;
                        $flash_name = $f;
                        break;
                    }
                } else {
                    $flash_id = $f->id;
                    $flash_name = $f;
                    break;
                }
            }
        }
        if ($request->type == "collection_by_goal") {
            $collection_goal = CollectionByGoal::where('collection_id', '!=', 0)->get();
            if ($collection_goal) {
                foreach ($collection_goal as $key => $col) {
                    $col_title = $request->language_id == 'en' ? $col->title_english : $col->title_arabic;
                    $collection[] = array('id' => $col->collection_id, 'title' => $col_title, 'type' => 'collection_by_goal');
                }
            }
        } else if ($request->type == "normal_collection") {
            $normal_collection = NormalCollection::where('collection_id', '!=', 0)->get();
            if ($normal_collection) {
                foreach ($normal_collection as $key => $col) {
                    $col_title = $request->language_id == 'en' ? $col->text_english : $col->text_arabic;
                    $collection[] = array('id' => $col->collection_id, 'title' => $col_title, 'type' => 'normal_collection');
                }
            }
        }
        if ($flash_id) {
            $sale_title = $request->language_id == 'en' ? $flash_name->title_english : $flash_name->title_arabic;
            $collection[] = array('id' => $flash_id, 'title' => $sale_title, 'type' => 'sale');
        }
        return response()->json([
            'success' => true,
            'collection' => $collection
        ]);
    }

    public function getCollectionProduct(Request $request)
    {
        $label = "";
        $show_option = true;
        $v_title = "";
        $product_id = [];
        $app_product = [];
        $product = [];
        if(isset($request->from)){
            if($request->from == 'view_all'){
                 ExclusiveViewAll::insert([
                    'count'       => 1,
                    'created_at' => Carbon::now('Asia/Kuwait'),
                    'updated_at' => Carbon::now('Asia/Kuwait')
                ]);
                
            }
        }
        if ($request->type == 'normal_collection' || $request->type == 'collection_by_goal') {
            if ($request->id == 0) {
                $collection_product = [];
                if ($request->type == 'normal_collection') {
                    $collection_ids = NormalCollection::where('collection_id', '!=', 0)->pluck('collection_id');
                } else if ($request->type == 'collection_by_goal') {
                    $collection_ids = CollectionByGoal::where('collection_id', '!=', 0)->pluck('collection_id');
                }

                foreach ($collection_ids as $normal) {
                    $shopify_product = CollectionProduct::where('collection_id', $normal)->get();
                    if (count($shopify_product) > 0) { // 200 OK
                        foreach ($shopify_product as $key => $prod) {
                            $collection_product[] = $prod->product_id;
                        }
                    }
                }
                $collection_ids_ordered = implode(',', array_unique($collection_product));

                if ($collection_ids_ordered) {
                    $product = Product::whereIn('product_id', array_unique($collection_product))->orderByRaw("FIELD(product_id, $collection_ids_ordered)")->get()->toArray();
                }
            } else {
                $shopify_product = CollectionProduct::where('collection_id', $request->id)->get();
                if (count($shopify_product) > 0) { // 200 OK
                    foreach ($shopify_product as $key => $prod) {
                        $product_id[$key] = $prod->product_id;
                    }
                    $ids_ordered = implode(',', $product_id);
                    $product = Product::whereIn('product_id', $product_id)->orderByRaw("FIELD(product_id, $ids_ordered)")->get()->toArray();
                }
            }
            if ($product != NULL) {
                foreach ($product as $p) {
                    $show_option = true;
                    //fetch only active product
                    $shopify_product = Product::where('product_id', $p['product_id'])->active()->where('is_delete', '=', 0)->first();
                    if ($shopify_product) {
                        $title = $request->language_id == 'en' ? $shopify_product->title_english : $shopify_product->title_arabic;
                        $variant_status = Variant::where('variant_id', $shopify_product->variant_id)->first();
                        $status = $variant_status->status;
                        $wishlist = Wishlist::where('customer_id', $request->customer_id)->where('variant_id', $shopify_product->variant_id)->where('status', 1)->first();
                        $user =  UserToken::where('device_id', $request->device_id)->first();
                        if ($user) {
                            $currency = $user->currency;
                        } else {
                            $currency = 'KWD';
                        }
                        if ($wishlist) {
                            $is_wishlist = true;
                        } else {
                            $is_wishlist = false;
                        }
                        if ($shopify_product->strike_price) {
                            // $strike_price = $shopify_product->strike_price;
                            $strike_price = $this->changeCurrency($currency, $shopify_product->strike_price);
                            $label = "SALE";
                        } else {
                            $label = "";
                            $strike_price = "";
                        }
                        if ($status == 'pre_order') {
                            if ($shopify_product->stock) {
                                $status = 'pre_order';
                            } else {
                                if ($shopify_product->inventory_policy == 'deny') {
                                    $status = "notify_me";
                                } else if ($shopify_product->inventory_policy == 'continue') {
                                    $status = 'pre_order';
                                }
                            }
                        }
                        $exclusive_label = $this->checkProductInExclusiveSection($shopify_product->product_id, $request->language_id);
                        if ($exclusive_label) {
                            $label = $exclusive_label;
                        }
                        if ($request->language_id == 'en') {
                            $variant_title = Variant::where('variant_id', $shopify_product->variant_id)->select('option1_english as option1', 'option2_english as option2', 'option3_english as option3')->first();
                        } else if ($request->language_id == 'ar') {
                            $variant_title = Variant::where('variant_id', $shopify_product->variant_id)->select('option1_arabic as option1', 'option2_arabic as option2', 'option3_arabic as option3')->first();
                        }
                        if ($variant_title) {
                            if ($variant_title->option1 == 'Default Title') {
                                $show_option = false;
                            }
                            if ($variant_title->option1 != null) {
                                $v_title = $variant_title->option1;
                            }
                            if ($variant_title->option2 != null) {
                                $v_title = $v_title . '/' . $variant_title->option2;
                            }
                            if ($variant_title->option3 != null) {
                                $v_title = $v_title . '/' . $variant_title->option3;
                            }
                        }
                        $price = $this->changeCurrency($currency, $shopify_product->price);
                        $app_product[] = array('product_id' => $shopify_product->product_id, 'image' => $shopify_product->image, 'title' => $title, 'price' => "$price", 'strike_price' => "$strike_price", 'currency' => $currency, 'label' => $label, 'variant_id' => $shopify_product->variant_id, 'status' => $status, 'show_option' => $show_option, 'variant_title' => $v_title, 'is_wishlist' => $is_wishlist);
                    }
                }
            }
        } else if ($request->type == 'sale') {
            $app_product = $this->getFlashSaleProduct($request->language_id, $request->id, $request->customer_id, $request->device_id);
        }

        return response()->json([
            'success' => true,
            'product' => $app_product
        ]);
    }

    public function getFlashSaleProduct($language_id, $flash_sale_id, $customer_id, $device_id)
    {
        $show_option = true;
        $v_title = "";
        $product = ExclusiveSection::where('flash_sale_id', $flash_sale_id)->orderBy('display_order', 'asc')->get()->toArray();
        $app_product = [];
        foreach ($product as $p) {

            $shopify_product = Product::where('product_id', $p['product_id'])->active()->where('is_delete', '=', 0)->first();
            if ($shopify_product) {
                $title = $language_id == 'en' ? $p['title_english'] : $p['title_arabic'];
                $variant_status = Variant::where('variant_id', $shopify_product->variant_id)->first();
                $status = $variant_status->status;
                $wishlist = Wishlist::where('customer_id', $customer_id)->where('variant_id', $shopify_product->variant_id)->where('status', 1)->first();
                $user =  UserToken::where('device_id', $device_id)->first();
                if ($user) {
                    $currency = $user->currency;
                } else {
                    $currency = 'KWD';
                }
                if ($wishlist) {
                    $is_wishlist = true;
                } else {
                    $is_wishlist = false;
                }
                if ($shopify_product->strike_price) {
                    $strike_price = $shopify_product->strike_price;
                    $strike_price = $this->changeCurrency($currency, $shopify_product->strike_price);
                    $label = "SALE";
                } else {
                    $label = "";
                    $strike_price = "";
                }
                if ($status == 'pre_order') {
                    if ($shopify_product->stock) {
                        $status = 'pre_order';
                    } else {
                        if ($shopify_product->inventory_policy == 'deny') {
                            $status = "notify_me";
                        } else if ($shopify_product->inventory_policy == 'continue') {
                            $status = 'pre_order';
                        }
                    }
                }
                $exclusive_label = $this->checkProductInExclusiveSection($shopify_product->product_id, $language_id);
                if ($exclusive_label) {
                    $label = $exclusive_label;
                }
                if ($language_id == 'en') {
                    $variant_title = Variant::where('variant_id', $shopify_product->variant_id)->select('option1_english as option1', 'option2_english as option2', 'option3_english as option3')->first();
                } else if ($language_id == 'ar') {
                    $variant_title = Variant::where('variant_id', $shopify_product->variant_id)->select('option1_arabic as option1', 'option2_arabic as option2', 'option3_arabic as option3')->first();
                }
                if ($variant_title) {
                    if ($variant_title->option1 == 'Default Title') {
                        $show_option = false;
                    }
                    if ($variant_title->option1 != null) {
                        $v_title = $variant_title->option1;
                    }
                    if ($variant_title->option2 != null) {
                        $v_title = $v_title . '/' . $variant_title->option2;
                    }
                    if ($variant_title->option3 != null) {
                        $v_title = $v_title . '/' . $variant_title->option3;
                    }
                }
                $price = $this->changeCurrency($currency, $shopify_product->price);
                $app_product[] = array('product_id' => $shopify_product->product_id, 'image' => $shopify_product->image, 'title' => $title, 'price' => "$price", 'strike_price' => "$strike_price", 'currency' => $currency, 'label' => $label, 'variant_id' => $shopify_product->variant_id, 'status' => $status, 'show_option' => $show_option, 'variant_title' => $v_title, 'is_wishlist' => $is_wishlist);
            }
        }
        return $app_product;
    }

    public function changeCurrency($currency, $price)
    {
        if ($currency) {
            if ($currency == 'KWD') {
                return $price;
            } else {
                $value = HelperController::changeCurrency('KWD', $currency, $price);
                return $value;
            }
        } else {
            return $price;
        }
    }

    public function checkProductInExclusiveSection($product_id, $language_id)
    {
        $label = "";
        $now = date('Y-m-d');
        $now_time = date('H:i:s');
        $flash_id = 0;
        $flash = FlashSale::where('start_date', '<=', $now)->get();
        foreach ($flash as $key => $f) {
            if ($f->status) {
                if ($f->start_date == $now) {
                    if ($f->start_time <= $now_time) {
                        if ($f->end_date >= $now) {
                            if ($f->end_date == $now) {
                                if ($f->end_time >= $now_time) {
                                    $flash_id = $f->id;
                                    break;
                                }
                            } else {
                                $flash_id = $f->id;
                                break;
                            }
                        }
                    }
                } else {
                    if ($f->end_date >= $now) {
                        if ($f->end_date == $now) {
                            if ($f->end_time >= $now_time) {
                                $flash_id = $f->id;
                                break;
                            }
                        } else {
                            $flash_id = $f->id;
                            break;
                        }
                    }
                }
            } else {
                if ($f->start_date == $now) {
                    if ($f->start_time <= $now_time) {
                        $flash_id = $f->id;
                        break;
                    }
                } else {
                    $flash_id = $f->id;
                    break;
                }
            }
        }
        if ($flash_id) {
            $flash_sale_new = FlashSale::where('id', $flash_id)->with('exclusive_section')->first();
            if ($flash_sale_new) {
                $exclusive = ExclusiveSection::where('flash_sale_id', $flash_sale_new->id)->where('product_id', $product_id)->first();
                if ($exclusive) {
                    if ($language_id == 'en') {
                        $label = $exclusive->label_english;
                    } else {
                        $label = $exclusive->label_arabic;
                    }
                }
            }
        }
        return $label;
    }
}
