<?php

namespace App\Http\Controllers\Api\AppSetting;

use Response;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Mail;
use App\Models\EmailSetting;
use App\Models\ContactUs;
use App\Mail\TestEmail;
use Carbon\Carbon;
// use mail;

class ContactUsController extends Controller
{

    public function sendMail(Request $request)
    {
        $admin_email = "";
        $emailSetting = EmailSetting::first();
        if ($emailSetting) {
            $admin_email = $emailSetting->email;
        }

        // Mail::send('emails.enquiry', ['contact_data' => $request->all()], function ($message) use ($admin_email) {
        //     $message->to($admin_email, 'Afrah Beauty')->subject('Contact us');
        // });
 
        // if (count(Mail::failures()) > 0) {
        //     if ($request->language_id == 'ar') {
        //         $msgErr = "حدث خطأ";
        //     } elseif ($request->language_id == 'en') {
        //         $msgErr = "Something went wrong.";
        //     }
        //     return response()->json([
        //         'success' => false,
        //         'msg' => $msgErr
        //     ]);

        // } else {
        //     if ($request->language_id == 'ar') {
        //         $msg = "لقد تم اتسلام رسالتك بنجاح و سوف نقوم بالرد بأسرع وقت ممكن ❤️";
        //     } elseif ($request->language_id == 'en') {
        //         $msg = "We got your message and we will reply as fast as possible ❤️";
        //     }
        //     return response()->json([
        //         'success' => true,
        //         'msg' => $msg
        //     ]);
        // }
        
        try{
        $data = ['name' => $request->name, 'message' => $request->message, 'email' => $request->email, 'admin_email' => $admin_email];

        Mail::to($admin_email)->send(new TestEmail($data));
        ContactUs::insert([
            'name'=>$request->name,
            'email'=>$request->email,
            'message'=>$request->message,
            'created_at' => Carbon::now('Asia/Kuwait'),
            'updated_at' => Carbon::now('Asia/Kuwait')
        ]);
        if ($request->language_id == 'ar') {
                $msg = "لقد تم اتسلام رسالتك بنجاح و سوف نقوم بالرد بأسرع وقت ممكن ❤️";
            } elseif ($request->language_id == 'en') {
                $msg = "We got your message and we will reply as fast as possible ❤️";
            }
            return response()->json([
                'success' => true,
                'msg' => $msg
            ]);
        }catch (Exception $e) {
            if ($request->language_id == 'ar') {
                $msgErr = "حدث خطأ";
            } elseif ($request->language_id == 'en') {
                $msgErr = "Something went wrong.";
            }
            return response()->json([
                'success' => false,
                'msg' => $msgErr
            ]);
        }
    }
}
