<?php

namespace App\Http\Controllers\Api\AppSetting;

use App\Http\Controllers\Admin\Helper\HelperController;
use App\Http\Controllers\Controller;
use App\Models\CountryCurrency;
use Illuminate\Http\Request;

class CurrencyChangeController extends Controller
{
    public function currencyRate()
    {
        // set API Endpoint, access key, required parameters
        $endpoint = 'convert';
        $access_key = '339c8df48ea768010ce9b6d69121c2ae';

        // initialize CURL:
        $ch = curl_init('https://api.exchangeratesapi.io/v1/latest?access_key=' . $access_key . '&base=KWD');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        // get the JSON data:
        $json = curl_exec($ch);
        curl_close($ch);

        // Decode JSON response:
        $conversionResult = json_decode($json, true);

        // access the conversion result
        if(count($conversionResult) > 0){
            $rates =  $conversionResult['rates'];

            if (count($rates) > 0) {
                foreach ($rates as $key => $rate) {
                    $update = CountryCurrency::where('code', $key)->update([
                        'rate' => $rate
                    ]);
                }
                if ($update) {
                    return response()->json([
                        'success' => true,
                        'msg' => 'Rate updated successfully.'
                    ]);
                } else {
                    return response()->json([
                        'success' => false,
                        'msg' => 'Something went wrong'
                    ]);
                }
            } else {
                return response()->json([
                    'success' => false,
                    'msg' => 'Something went wrong'
                ]);
            }
        }else{
            return response()->json([
                'success' => false,
                'msg' => 'Something went wrong'
            ]);
        }

    }

    public function getRate()
    {
        $rate = HelperController::changeCurrency('KWD', 'INR', 10);
        echo $rate;
    }

    public function getCurrencyCodeList()
    {
        $currency = CountryCurrency::where('flag','!=',null)->orderBy('code')->select('id', 'code', 'flag')->get()->map(function ($curre) {
            if($curre->flag){
                $curre->flag = 'storage/app/' . $curre->flag;
            }
            
            return $curre;
        });
        return response()->json([
            'count' => count($currency),
            'success' => true,
            'record' => $currency
        ]);
    }
}
