<?php

namespace App\Http\Controllers\Api\AppSetting;

use Response;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\User;
use App\Models\Banner;
use App\Models\CollectionByGoal;
use App\Models\NormalCollection;
use App\Models\AnnouncementBar;
use App\Models\AppVersion;
use App\Models\FlashSale;
use App\Http\Controllers\Admin\Helper\HelperController;
use App\Models\ExclusiveSection;
use App\Models\Menu;
use App\Models\Product;
use App\Models\UserToken;
use App\Models\Variant;
use Carbon\Carbon;
use GuzzleHttp\Client;

class HomePageController extends Controller
{
    public $client;
    public function __construct()
    {
        $this->client = new Client();
    }

    public function getHomePageData(Request $request)
    {
        $banner = [];
        $banner_data = [];
        $normal_collection = [];
        $collection_goal = [];
        $announcement = [];

        $now = Carbon::now('Asia/Kuwait')->format('Y-m-d');
        $now_time = Carbon::now('Asia/Kuwait')->format('H:i:s');

        // $now = date('Y-m-d');
        // $now_time = date('H:i:s');
        $flash_id = 0;
        $user =  UserToken::where('device_id', $request->device_id)->first();
        if ($user) {
            $currency = $user->currency;
        } else {
            $currency = 'KWD';
        }
        $flash = FlashSale::where('start_date', '<=', $now)->get();
        foreach ($flash as $key => $f) {
            if ($f->status) {
                if ($f->start_date == $now) {
                    if ($f->start_time <= $now_time) {
                        if ($f->end_date >= $now) {
                            if ($f->end_date == $now) {
                                if ($f->end_time >= $now_time) {
                                    $flash_id = $f->id;
                                    break;
                                }
                            } else {
                                $flash_id = $f->id;
                                break;
                            }
                        }
                    }
                } else {
                    if ($f->end_date >= $now) {
                        if ($f->end_date == $now) {
                            if ($f->end_time >= $now_time) {
                                $flash_id = $f->id;
                                break;
                            }
                        } else {
                            $flash_id = $f->id;
                            break;
                        }
                    }
                }
            } else {
                if ($f->start_date == $now) {
                    if ($f->start_time <= $now_time) {
                        $flash_id = $f->id;
                        break;
                    }
                } else {
                    $flash_id = $f->id;
                    break;
                }
            }
        }
        if ($request->language_id == 'en') {
            $flash_sale_new = FlashSale::where('id', $flash_id)->select('id', 'start_date', 'start_time', 'end_date', 'end_time', 'status', 'is_show_quantity', 'title_english as title')->first();
            $banner_lang = 'english';
            $banner = Banner::where('banner_language', $banner_lang)->orderBy('display_order', 'asc')->select('id', 'type_of_banner', 'upload_banner_type', 'cover_image', 'banner_url', 'destination_type', 'destination', 'banner_language')->get()->map(function ($doctor) use($request){
                $doctor->banner_url = 'storage/app/' . $doctor->banner_url;
                if ($doctor->cover_image) {
                    $doctor->cover_image = 'storage/app/' . $doctor->cover_image;
                } else {
                    $doctor->cover_image = "";
                }
                if (!$doctor->destination_type) {
                    $doctor->destination_type = "";
                }
                if (!$doctor->destination) {
                    $doctor->destination = "";
                }
                if($doctor->destination_type == 'menu'){
                    $menuData = Menu::where('id', $doctor->destination)->first();
                    if($menuData){
                        $doctor->destination = $menuData->link;
                    }
                }
                $doctor->collection_type = "";
                $doctor->collection_title = "";
                if($doctor->destination_type == 'collection'){
                    $normal = NormalCollection::where('collection_id',$doctor->destination)->first();
                    if($normal){
                       $doctor->collection_type = "normal_collection"; 
                       if($request->language_id=='en'){
                          $doctor->collection_title = $normal->text_english; 
                       }else{
                           $doctor->collection_title = $normal->text_arabic;
                       }
                       
                    }else{
                        $goal = CollectionByGoal::where('collection_id',$doctor->destination)->first();
                        if($goal){
                          if($request->language_id=='en'){
                          $doctor->collection_title = $goal->title_english; 
                       }else{
                           $doctor->collection_title = $goal->title_arabic;
                       }  
                        }
                        
                        $doctor->collection_type = "collection_by_goal";
                    }
                }
                
                return $doctor;
            });
            $normal_collection = NormalCollection::where('collection_id', '!=', 0)->select('id', 'text_english as text', 'collection_image', 'collection_image_type', 'collection_id')->get()->map(function ($doctor) {
                $doctor->collection_image = 'storage/app/' . $doctor->collection_image;
                $doctor->type = 'normal_collection';
                return $doctor;
            });
            $collection_goal = CollectionByGoal::where('collection_id', '!=', 0)->orderBy('display_order', 'asc')->select('id', 'title_english as title', 'collection_id', 'collection_image')->get()->map(function ($goal) {
                if ($goal->collection_image) {
                    $goal->collection_image = 'storage/app/' . $goal->collection_image;
                } else {
                    $goal->collection_image = "";
                }
                return $goal;
            });
            $announcement = AnnouncementBar::where('start_date', '<=', $now)->whereNull('end_date')->first();
            if ($announcement) {
                $announcement = AnnouncementBar::where('start_date', '<=', $now)->whereNull('end_date')->select('text_english as text')->first();
            } else {
                $announcement = AnnouncementBar::where('start_date', '<=', $now)->where('end_date', '>=', $now)->select('text_english as text')->first();
            }


            // echo "<pre>";
            // echo $flash_sale_new;die;
            // print_r($flash_sale_new);die;
            // $flash_sale_new = $flash_sale_new->with(['exclusive_section' => function ($query) {
            //     $query->orderBy('display_order', 'asc')->select('product_id', 'flash_sale_id', 'title_english as title', 'quantity', 'label_english as label', 'product_view')->get();
            // }])->select('id', 'start_date', 'start_time', 'end_date', 'end_time', 'status', 'is_show_quantity', 'title_english as title')->first();
        } else if ($request->language_id == 'ar') {
            $flash_sale_new = FlashSale::where('id', $flash_id)->select('id', 'start_date', 'start_time', 'end_date', 'end_time', 'status', 'is_show_quantity', 'title_arabic as title')->first();
            $banner_lang = 'arabic';
            $banner = Banner::where('banner_language', $banner_lang)->orderBy('display_order', 'asc')->select('id', 'type_of_banner', 'upload_banner_type', 'cover_image', 'banner_url', 'destination_type', 'destination', 'banner_language')->get()->map(function ($doctor) {
                $doctor->banner_url = 'storage/app/' . $doctor->banner_url;
                if ($doctor->cover_image) {
                    $doctor->cover_image = 'storage/app/' . $doctor->cover_image;
                } else {
                    $doctor->cover_image = "";
                }
                if (!$doctor->destination_type) {
                    $doctor->destination_type = "";
                }
                if (!$doctor->destination) {
                    $doctor->destination = "";
                }
                if($doctor->destination_type == 'menu'){
                    $menuData = Menu::where('id', $doctor->destination)->first();
                    if($menuData){
                        $doctor->destination = $menuData->link;
                    }
                }
                return $doctor;
            });
            $normal_collection = NormalCollection::where('collection_id', '!=', 0)->select('id', 'text_arabic as text', 'collection_image', 'collection_image_type', 'collection_id')->get()->map(function ($doctor) {
                $doctor->collection_image = 'storage/app/' . $doctor->collection_image;
                $doctor->type = 'normal_collection';
                return $doctor;
            });
            $collection_goal = CollectionByGoal::where('collection_id', '!=', 0)->orderBy('display_order', 'asc')->select('id', 'title_arabic as title', 'collection_id', 'collection_image')->get()->map(function ($goal) {
                if ($goal->collection_image) {
                    $goal->collection_image = 'storage/app/' . $goal->collection_image;
                } else {
                    $goal->collection_image = "";
                }
                return $goal;
            });
            $announcement = AnnouncementBar::where('start_date', '<=', $now)->whereNull('end_date')->first();
            if ($announcement) {
                $announcement = AnnouncementBar::where('start_date', '<=', $now)->whereNull('end_date')->select('text_arabic as text')->first();
            } else {
                $announcement = AnnouncementBar::where('start_date', '<=', $now)->where('end_date', '>=', $now)->select('text_arabic as text')->first();
            }

            // $flash_sale_new = $flash_sale_new->with(['exclusive_section' => function ($query) {
            //     $query->orderBy('display_order', 'asc')->select('product_id', 'flash_sale_id', 'title_arabic as title', 'quantity', 'label_arabic as label', 'product_view')->get();
            // }])->select('id', 'start_date', 'start_time', 'end_date', 'end_time', 'status', 'is_show_quantity', 'title_arabic as title')->first();



        }
        if (!$announcement) {
            $announcement = "";
        } else {
            $announcement = $announcement->text;
        }
        $version = AppVersion::select('android_version', 'ios_version')->first();
        if ($version) {
            $app_version = ['android' => $version->android_version, 'ios' => $version->ios_version];
        }else{
            $app_version = ['android' => "", 'ios' => ""];
        }

        if ($flash_sale_new) {
            if ($flash_sale_new->status) {
                $d1 = strtotime($flash_sale_new->end_date." ".$flash_sale_new->end_time);
                $d2 = strtotime($now." ".$now_time);
                $totalSecondsDiff = abs($d1-$d2); 
                $no_of_second = $totalSecondsDiff;
                // $no_of_second = (strtotime($flash_sale_new->end_date) + strtotime($flash_sale_new->end_time)) - (strtotime($now) + strtotime($now_time));
            } else {
                $no_of_second = 0;
            }

            $flash_sale_new['seconds'] = $no_of_second;
            unset($flash_sale_new['start_date']);
            unset($flash_sale_new['start_time']);
            unset($flash_sale_new['end_date']);
            unset($flash_sale_new['end_time']);

            $flashExclusiveSections = ExclusiveSection::where('flash_sale_id', $flash_sale_new->id)->get();
            if (count($flashExclusiveSections)) {
                $flashSaleData = [];
                $flashSaleNewData = []; 
                $flash_sale_new['product_view'] = $flashExclusiveSections[0]['product_view'];
                foreach ($flashExclusiveSections as $key => $flash) {
                    $product_data = Product::where('product_id',$flash->product_id)->where('active', '=', 1)->where('is_delete', '=', 0)->first();
                    if($product_data){
                        $flashSaleData['product_id'] = $flash->product_id;
                        $flashSaleData['flash_sale_id'] = $flash->flash_sale_id;
                        $flashSaleData['title'] = $request->language_id == "en" ?  $flash->title_english : $flash->title_arabic;
                        $flashSaleData['quantity'] = $flash->quantity;
                        $flashSaleData['label'] = $request->language_id == "en" ? $flash->label_english : $flash->label_arabic;
                        $variant_data = Variant::where('variant_id',$product_data->variant_id)->first();
                        if ($variant_data->image) {
                            // $flash->image = $variant_data->image;
                            $flashSaleData['image'] = $variant_data->image;

                        } else {
                            // $flash->image = "";
                            $flashSaleData['image'] = "";
                        }
                        $price = $this->changeCurrency($currency, $variant_data->price);
                        // $flash->price = "$price";
                        $flashSaleData['price'] = "$price";
                        // $flash->price = $product->variants[0]->price;

                        // $flash->remaining = $variant_data->stock;
                        $flashSaleData['remaining'] = $variant_data->stock;

                        $strike_price = $this->changeCurrency($currency, $variant_data->strike_price);
                        // $flash->strike_price = "$strike_price";
                        $flashSaleData['strike_price'] = "$strike_price";
                        // $flash->strike_price = $product->variants[0]->compare_at_price;
                        if ($flashSaleData['remaining'] > $flashSaleData['quantity']) {
                            ExclusiveSection::where('flash_sale_id', $flash_sale_new->id)->where('product_id', $flash->product_id)->update([
                                'quantity' => $variant_data->stock
                            ]);
                            $flashSaleData['quantity'] = $variant_data->stock;
                        }
                        // if ($flash->remaining > $flash->quantity) {
                        //     ExclusiveSection::where('flash_sale_id', $flash_sale_new->id)->where('product_id', $flash->product_id)->update([
                        //         'quantity' => $variant_data->stock
                        //     ]);
                        //     $flashSaleData['quantity'] = $variant_data->stock;
                        // }
                        if (!$flashSaleData['label']) {
                            $flashSaleData['label'] = "";
                            // $flash->label = "";
                            // if ($flash->strike_price) {
                            //     $flash->label = "SALE";
                            // }
                            if ($flashSaleData['strike_price']) {
                                $flashSaleData['label'] = "SALE";
                            }
                        }
                        if (!$flashSaleData['strike_price']) {
                            $flashSaleData['strike_price'] = "";
                        }
                        // if (!$flash->strike_price) {
                        //     $flash->strike_price = "";
                        // }
                        $flashSaleData['currency'] = $currency;
                        // $flash->currency = $currency;
                        unset($flash->product_view);
                        // $flash_sale_new->exclusive_section[$key] = $flashSaleData;
                        $flashSaleNewData[] = $flashSaleData;
                        // $keyCount++;
                    }
                }
                // echo "<pre>";
                // print_r($flashSaleNewData);die;
                $flash_sale_new['exclusive_section'] = $flashSaleNewData;
                // print_r($flash_sale_new->exclusive_section);die;
                // array_push($flash_sale_new->exclusive_section , $flashSaleNewData);
                // $flash_sale_new->exclusive_section = $flashSaleNewData;
                // $mergeArr = array_merge( $flash_sale_new->exclusive_section, $flashSaleNewData );
                // print_r($flash_sale_new->exclusive_section);die;
                // print_r($flash_sale_new->exclusive_section->toArray());die;
                // array_push($flash_sale_new->exclusive_section, $flashSaleNewData);
                // print_r($flash_sale_new->toArray());die;
                // print_r($flash_sale_new->exclusive_section);die;
            }else{
                $flash_sale_new['exclusive_section'] = [];
            }
        }
        if (count($banner) > 0) {
            $banner_data = [];
            $banner_data['type_of_banner'] = $banner[0]['type_of_banner'];
            $banner_data['banner'] = [];
            foreach ($banner as $key => $b) {
                unset($b->type_of_banner);
                $banner_data['banner'][$key] = $b;
            }
        }
        if (!$flash_sale_new) {
            $flash_sale_new = "";
        }
        foreach ($collection_goal as $goal) {
            $goal->type = "collection_by_goal";
        }
        return response()->json([
            'success' => true,
            'banner_data' => $banner_data,
            'collection_by_goal' => $collection_goal,
            'normal_collection' => $normal_collection,
            'announcement_bar' => $announcement,
            'app_version' => $app_version,
            'flash_sale' => $flash_sale_new
        ]);
    }

    public function changeCurrency($currency, $price){
        if($currency){
            if($currency == 'KWD'){
                return $price;
            }else{
                $value = HelperController::changeCurrency('KWD', $currency, $price);
                return $value;
            }
        }else{
            return $price;
        }
    }
}
