<?php

namespace App\Http\Controllers\Api\AppSetting;

use App\Http\Controllers\Controller;
use App\Models\CurrencyPoint;
use App\Models\Customer;
use App\Models\Milestone;
use App\Models\MilestonePoint;
use App\Models\MilestoneViewCount;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class MilestoneController extends Controller
{
    public function getCustomerMilestone(Request $request){
        $label = "";
        $customer = Customer::where('customer_id', $request->customer_id)->select('customer_id', 'currency','point', 'extra_point')->first();
        if ($request->language_id == 'en') {
            $milestones = Milestone::select('id', 'level_english as level', 'milestone_image' ,'from_point', 'to_point', 'prize_english as prize', 'note_english as note', 'optional_note_english as optional_note')->get()->toArray();
        } else if ($request->language_id == 'ar') {
            $milestones = Milestone::select('id', 'level_arabic as level', 'milestone_image' ,'from_point', 'to_point', 'prize_arabic as prize', 'note_arabic as note', 'optional_note_arabic as optional_note')->get()->toArray();
        }
        // $customerPoint->milestones = $milestones;
        foreach($milestones as $key => $milestone){
            $milestones[$key]['milestone_image'] = 'storage/app/'.$milestone['milestone_image'];
            $milestones[$key]['prize'] = 'storage/app/'.$milestone['prize'];
            $milestones[$key]['to_point'] = $milestone['to_point'] != NULL ?  $milestone['to_point']: 0;
            // $milestones[$key]['optional_note'] = $milestones[$key]['optional_note'] != NULL ? $milestones[$key]['optional_note'] : "";
        }
        if($customer){
            $customer_points = $customer->point + $customer->extra_point;
            $customerPoint = [
                'customer_id'=> $customer->customer_id,
                'level'=> NULL,
                'point'=> $customer_points,
                'next_point'=> 0,
                'currency' => NULL,
                'each_value' => NULL,
                'each_point' => NULL
            ];
            $currencyPoint = CurrencyPoint::where('currency', $customer->currency)->select('currency', 'each_value', 'each_point')->first();
            $next_point = Milestone::where('from_point' , ">", $customer_points)->select('level_english','from_point')->first();
            $level = $this->getLevel($customer_points, $request->language_id);
            if($next_point){
                $point = abs($next_point->from_point - $customer_points);
            }else{
                $point = 0;
            }
            if($currencyPoint){
                if($request->language_id == "en"){
                    $label = "Each ".$currencyPoint->each_value." ".$currencyPoint->currency." = ".$currencyPoint->each_point." points";
                }elseif($request->language_id == "ar"){
                    $label = "كل"." ".$currencyPoint->each_value." ".$currencyPoint->currency." = ".$currencyPoint->each_point." "."نقاط"; 
                }
                $customerPoint['level'] = $level;
                $customerPoint['next_point'] = $point;
                $customerPoint['currency'] = $currencyPoint->currency;
                $customerPoint['each_value'] = $currencyPoint->each_value;
                $customerPoint['each_point'] = $currencyPoint->each_point;
                $customerPoint['label'] = $label;
            }else{
                $currencyPointData = CurrencyPoint::where('currency', 'KWD')->select('currency', 'each_value', 'each_point')->first();
                // if($currencyPointData){
                //     $customerPoint['level'] = $level;
                //     $customerPoint['next_point'] = $point;
                //     $customerPoint['currency'] = $currencyPointData->currency;
                //     $customerPoint['each_value'] = $currencyPointData->each_value;
                //     $customerPoint['each_point'] = $currencyPointData->each_point;
                // }else{
                //     $customerPoint['level'] = $level;
                //     $customerPoint['next_point'] = $point;
                //     $customerPoint['currency'] = 'KWD';
                //     $customerPoint['each_value'] = 1;
                //     $customerPoint['each_point'] = 2;
                // }
                $customerPoint['level'] = $level;
                $customerPoint['next_point'] = $point;
                $customerPoint['currency'] = $currencyPointData->currency;
                $customerPoint['each_value'] = $currencyPointData->each_value;
                $customerPoint['each_point'] = $currencyPointData->each_point;
            }
            return response()->json([
                'success' => true,
                'customer_milestone' => $customerPoint,
                'milestone' => $milestones,
            ]);
        }else{
            if ($request->language_id == 'ar') {
                            $msg = "الحساب غير مسجل";
                        } elseif ($request->language_id == 'en') {
                            $msg = "Customer does not exist";
                        }
            return response()->json([
                'success' => false,
                'msg' => $msg
            ]);
        }
    }

    public function getMilestone(Request $request){
        if ($request->language_id == 'en') {
            $milestones = Milestone::where('id', $request->id)->select('id', 'level_english as level', 'milestone_image' ,'from_point', 'to_point', 'prize_english as prize', 'note_english as note', 'optional_note_english as optional_note')->first();
            // $milestones->view_prize_count = $milestones->view_prize_count + 1;
            // $milestones->save();
            // unset($milestones->view_prize_count);
            // unset($milestones->updated_at);
        } else if ($request->language_id == 'ar') {
            $milestones = Milestone::where('id', $request->id)->select('id', 'level_arabic as level', 'milestone_image' ,'from_point', 'to_point', 'prize_arabic as prize', 'note_arabic as note', 'optional_note_arabic as optional_note')->first();
            // $milestones->view_prize_count = $milestones->view_prize_count + 1;
            // $milestones->save();
            // unset($milestones->view_prize_count);
            // unset($milestones->updated_at);
        }
        if($milestones){
            $milestones->milestone_image = 'storage/app/' . $milestones->milestone_image;
            $milestones->prize = 'storage/app/' . $milestones->prize;
            $milestones->to_point = $milestones->to_point != NULL ?  $milestones->to_point: 0;

            MilestoneViewCount::insert([
                'milestone_id' => $milestones->id,
                'created_at' => Carbon::now('Asia/Kuwait'),
                'updated_at' => Carbon::now('Asia/Kuwait')
            ]);
            // $milestones->optional_note = $milestones->optional_note != NULL ? $milestones->optional_note : "";
            return response()->json([
                'success' => true,
                'milestone' => $milestones,
            ]);
        }else{
            if ($request->language_id == 'ar') {
                $msgErr = "حدث خطأ";
            } elseif ($request->language_id == 'en') {
                $msgErr = "Something went wrong";
            }
            return response()->json([
                'success' => false,
                'msg' => $msgErr
            ]);
        }
    }

    public function getLevel($point, $language){
        $max = Milestone::max('from_point');
        if($point >= $max){
            if ($language == 'en') {
                $milestone = Milestone::where('from_point', '=',$max)->select('level_english as level')->first();
            } else if ($language == 'ar') {
                $milestone = Milestone::where('from_point', '=',$max)->select('level_arabic as level')->first();
            }
            if($milestone){
                return $milestone->level;
            }else{
                return 'Not Available';
            }
            // echo $milestone->level;die;
        }else{
            if ($language == 'en') {
                $milestone = Milestone::where('from_point', '<=',$point)->where('to_point', '>=',$point)->select('level_english as level')->first();
            } else if ($language == 'ar') {
                $milestone = Milestone::where('from_point', '<=',$point)->where('to_point', '>=',$point)->select('level_arabic as level')->first();
            }
            if($milestone){
                return $milestone->level;
            }else{
                return 'Not Available';
            }
            // echo $milestone->level;die;
        }
    }

    public function getCurrencyMilestone(Request $request){
        $currencyPoint = CurrencyPoint::where('currency', $request->currency)->select('currency', 'each_value', 'each_point')->first();
        if ($request->language_id == 'en') {
            $milestones = Milestone::select('id', 'level', 'reach_value', 'prize_english as prize', 'note_english as note')->get()->toArray();
        } else if ($request->language_id == 'ar') {
            $milestones = Milestone::select('id', 'level', 'reach_value', 'prize_arabic as prize', 'note_arabic as note')->get()->toArray();
        }
        if($currencyPoint){
            $customer = MilestonePoint::where('customer_id', $request->customer_id)->select('customer_id', 'point')->first();
            if($customer){
                $customer['customer_id'] = $request->customer_id;
                $customer['point'] = $customer->point;
                $customer['currency'] = $currencyPoint->currency;
                $customer['each_value'] = $currencyPoint->each_value;
                $customer['each_point'] = $currencyPoint->each_point;
            }else{
                $customer = [
                    'customer_id'=> $request->customer_id,
                    'point'=> 0,
                    'currency' => $currencyPoint->currency,
                    'each_value' => $currencyPoint->each_value,
                    'each_point' => $currencyPoint->each_point
                ];
            }
            return response()->json([
                'success' => true,
                'customer_milestone' => $customer,
                'milestone' => $milestones,
            ]);
        }else{
            $currencyPoint = CurrencyPoint::where('currency', 'KWD')->select('currency', 'each_value', 'each_point')->first();
            $customerPoint = MilestonePoint::where('customer_id', $request->customer_id)->select('customer_id', 'point')->first();

            $customerPoint = [
                'customer_id'=> $request->customer_id,
                'point'=> $customerPoint != NULL ? $customerPoint->point : 0,
                'currency' => $currencyPoint->currency,
                'each_value' => $currencyPoint->each_value,
                'each_point' => $currencyPoint->each_point,
            ];
            return response()->json([
                'success' => true,
                'customer_milestone' => $customerPoint,
                'milestone' => $milestones,
            ]);
        }
    }

    
}
