<?php

namespace App\Http\Controllers\Api\AppSetting;

use Response;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\SciencePage;

class SciencePageController extends Controller
{

    public function getSciencePageData(Request $request)
    {
        if ($request->language_id == 'en') {
            $page = SciencePage::where('active', 1)->where('language', 'english')->with(['content' => function ($query) {
                $query->select('science_page_id', 'data', 'type');
            }])->select('id', 'title')->first();
        } else if ($request->language_id == 'ar') {
            $page = SciencePage::where('active', 1)->where('language', 'arabic')->with(['content' => function ($query) {
                $query->select('science_page_id', 'data', 'type');
            }])->select('id', 'title')->first();
        }
        if ($page) {
            foreach ($page->content as $content) {
                if ($content['type'] == 'image') {
                    if ($content['data']) {
                        $content['data'] = 'storage/app/' . $content['data'];
                        $path_info = pathinfo($content['data']);
                        $content['image_type'] = $path_info['extension'];
                    } else {
                        $content['data'] = "";
                        $content['image_type'] = "";
                    }
                } else {
                    $content['image_type'] = "";
                }
            }
        }
        return response()->json([
            'success' => true,
            'science_page' => $page
        ]);
    }
}
